/*
 *        JacORB - a free Java ORB
 *
 *   Copyright (C) 1997-2002  Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package net.starmiddleware.starws2.I2WCFE.idl;

/**
 * @author Gerald Brose
 * @version $Id: IllegalRedefinition.java,v 1.1 2004/07/13 02:13:55 jane Exp $
 */


class IllegalRedefinition
        extends NameAlreadyDefined
{

    public String oldDef;
    public String newDef;

    public IllegalRedefinition()
    {
    }

    public IllegalRedefinition( String s )
    {
        super( s );
        newDef = s;
    }

    public IllegalRedefinition( String oldDef, String newDef )
    {
        super( oldDef );
        this.oldDef = oldDef;
        this.newDef = newDef;
    }


}


