package net.starmiddleware.starws2.encoding;

/**
 * <p>Title: serialization for complextypes based on array</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author shuichao
 * @version 1.0
 */

import java.io.*;
import javax.xml.namespace.*;

import org.apache.axis.*;
import org.apache.axis.encoding.*;
import org.apache.axis.wsdl.fromJava.*;
import org.xml.sax.*;
import net.starmiddleware.starws2.encoding.java.*;

public class ArrayBeseTypeSer
    implements Serializer {
  public ArrayBeseTypeSer(Class javaType, QName xmlType) {
    // this(javaType, xmlType, TypeDesc.getTypeDescForClass(javaType));
  }

  public ArrayBeseTypeSer() {
  }

  public void serialize(QName name, Attributes attributes,
                        Object value, SerializationContext context) throws
      IOException {

    context.startElement(name, attributes);

    Object realValue = ( (ArrayBaseType) value).getValue();
    int length = java.lang.reflect.Array.getLength(realValue);
    for (int i = 0; i < length; i++) {
      org.xml.sax.helpers.AttributesImpl attri = new org.xml.sax.helpers.
          AttributesImpl();
      Object temp = java.lang.reflect.Array.get(realValue, i);
      QName eleName = new QName("", "item");
      QName typeName = context.getQNameForClass(temp.getClass());
      String prefix = context.getPrefixForURI(typeName.getNamespaceURI());

      attri.addAttribute("", "xsi:type", "xsi:type", "CDATA",
                         prefix + ":" + typeName.getLocalPart());
      attri.addAttribute("", "xmlns:" + prefix, "xmlns:" + prefix, "CDATA",
                         typeName.getNamespaceURI());
      Class cls = context.getTypeMapping().getClassForQName(typeName);
      Serializer ser = context.getSerializerForJavaType(cls);
      ser.serialize(eleName, attri, temp, context);
    }
    context.endElement();

  }

  public String getMechanismType() {
    return Constants.AXIS_SAX;
  }

  public boolean writeSchema(Types types) throws Exception {
    return true;
  }
}
