package net.starmiddleware.starws2.encoding;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import javax.xml.namespace.*;

import org.apache.axis.*;
import org.apache.axis.encoding.*;
import org.apache.axis.message.*;
import org.apache.axis.utils.*;
import org.xml.sax.*;
import net.starmiddleware.starws2.encoding.CORBA.*;

public class CORBAComplexDesr extends DeserializerImpl {

  public CORBAComplexDesr() {
    this.setDefaultType(new QName("http://www.omg.org/IDL-Mapped/","corba"));
  }
  DeserializerImpl currentHandler=null;
  StringBuffer buffer=new StringBuffer();
  boolean isInit=false;
  ComplexType CORBAValue=new ComplexType();
  /**
     * Append any characters received to the value.  This method is defined
     * by Deserializer.
     */
    public void characters(char [] chars, int start, int end)
        throws SAXException
    {
       if(chars[0]=='\n') return;
       buffer.append(chars);
    }
    /**
       * onStartChild is called on each child element.
       * The default behavior supplied by DeserializationImpl is to do nothing.
       * A specific deserializer may perform other tasks.  For example a
       * BeanDeserializer will construct a deserializer for the indicated
       * property and return it.
       * @param namespace is the namespace of the child element
       * @param localName is the local name of the child element
       * @param prefix is the prefix used on the name of the child element
       * @param attributes are the attributes of the child element
       * @param context is the deserialization context.
       * @return is a Deserializer to use to deserialize a child (must be
       * a derived class of SOAPHandler) or null if no deserialization should
       * be performed.
       */
      public SOAPHandler onStartChild(String namespace, String localName,
                               String prefix, Attributes attributes,
                               DeserializationContext context)
          throws SAXException
      {

            QName type = context.getTypeFromAttributes(namespace,
                                                       localName,
                                                       attributes);
            // If no type is specified, use the defaultType if available.
            // xsd:string is used if no type is provided.
            if (type == null) {
                type = defaultType;
                if (type == null) {
                    type = Constants.XSD_STRING;
                }
            }

            if (log.isDebugEnabled()) {
                log.debug(Messages.getMessage("gotType00", "Deser", "" + type));
            }

            // We know we're deserializing, but we don't have
            // a specific deserializer.  So create one using the
            // attribute type qname.
            if (type != null) {
                if(type.getNamespaceURI().equals("http://www.omg.org/IDL-Mapped/")){
                  type = defaultType;
                }
                //else{
                  Deserializer dser = (Deserializer) context.getDeserializerForType(type);
                  if (dser != null) {
                    currentHandler=(DeserializerImpl) dser;
                  }
                  else {
                    throw new SAXException(
                        Messages.getMessage("noDeser00", "" + type));
                  }
                //}
            }


           return (SOAPHandler)currentHandler;

      }

    public void onEndElement(String namespace, String localName,
                           DeserializationContext context)
        throws SAXException
    {
        if (isNil || CORBAValue == null) {
            value = null;
            return;
        }
        /*
        Object o=top.get(top.size()-1);
        top.remove(top.size()-1);
        if(top.size()>0){
          ((ArrayList)top.get(top.size()-1)).add(o);

        }
        value=o;
       */
      if(buffer.toString().length()>0)      CORBAValue.setValue(buffer.toString());
      value=CORBAValue;
    }
    /**
     * Reset deserializer for re-use
     */
    public void reset() {
        CORBAValue.init();
        buffer.setLength(0);// Reset string buffer back to zero
        isNil = false; // Don't know if nil
        isEnded = false; // Indicate the end of element not yet called
    }
    /**
      * This method is invoked after startElement when the element requires
      * deserialization (i.e. the element is not an href and the value is not nil.)
      * DeserializerImpl provides default behavior, which simply
      * involves obtaining a correct Deserializer and plugging its handler.
      * @param namespace is the namespace of the element
      * @param localName is the name of the element
      * @param prefix is the prefix of the element
      * @param attributes are the attributes on the element...used to get the type
      * @param context is the DeserializationContext
      */
     public void onStartElement(String namespace, String localName,
                              String prefix, Attributes attributes,
                              DeserializationContext context)
         throws SAXException
     {

     }
     public void onEndChild(String namespace, String localName,
                          DeserializationContext context)
       throws SAXException
   {

     CORBAValue.add(currentHandler.getValue());
   }

}
