package net.starmiddleware.starws2.encoding;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.io.*;
import javax.xml.namespace.*;

import org.apache.axis.*;
import org.apache.axis.encoding.*;
import org.apache.axis.wsdl.fromJava.*;
import org.xml.sax.*;
import net.starmiddleware.starws2.encoding.CORBA.*;

public class CharacterSer
    implements Serializer {
  public static final String NAME = "char";

  public CharacterSer() {

  }

  /** SERIALIZER STUFF
   */
  /**
   * Serialize an element named name, with the indicated attributes
   * and value.
   * @param name is the element name
   * @param attributes are the attributes...serialize is free to add more.
   * @param value is the value
   * @param context is the SerializationContext
   */
  public void serialize(QName name, Attributes attributes,
                        Object value, SerializationContext context) throws
      IOException {
    if (! (value instanceof typeAbstract))
      throw new IOException("Can't serialize a " + value.getClass().getName() +
                            " with a DataSerializer.");
    Character data = (Character) ( (typeAbstract) value).getValue();

    context.startElement(name, attributes);
    if (value != null) {
      context.writeSafeString(data.toString());
    }

    context.endElement();
  }

  public String getMechanismType() {
    return Constants.AXIS_SAX;
  }

  /**
   * Return XML schema for the specified type, suitable for insertion into
   * the <types> element of a WSDL document.
   *
   * @param types the Java2WSDL Types object which holds the context
   *              for the WSDL being generated.
   * @return true if we wrote a schema, false if we didn't.
   * @see org.apache.axis.wsdl.fromJava.Types
   */
  public boolean writeSchema(Types types) throws Exception {
    return false;
  }
}
