package net.starmiddleware.starws2.security.rbac;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Date;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.axis.*;
import org.w3c.dom.*;
import java.io.*;
import org.apache.axis.utils.XMLUtils;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */


public class RBACUtil {

    //¼ûϢ
    public static void log4User (String logFile, String info) throws AxisFault{
	try {

	    FileWriter fw = new FileWriter(logFile, true);
	    PrintWriter pw = new PrintWriter(fw);
            pw.println("*******************************");
            pw.println(new Date());
            pw.println(info);
            pw.println();
            pw.close();

	}catch (Exception e){
            throw AxisFault.makeFault(e);
        }
    }


    public static void log4Role(String logFile, String info) throws AxisFault {
	try {

	    FileWriter fw = new FileWriter(logFile, true);
	    PrintWriter pw = new PrintWriter(fw);
            pw.println("--------------------------------");
            pw.println(new Date());
	    pw.println(info);
	    pw.close();

	}
	catch (Exception e) {
	    throw AxisFault.makeFault(e);
	}
    }

    public static void log4String(String logFile, String info)throws AxisFault{
        try{

            FileWriter fw = new FileWriter(logFile, true);
	    PrintWriter pw = new PrintWriter(fw);
            pw.println();
            pw.println();
            pw.println();
            pw.println("===============================================================");
            pw.println(new Date());
            pw.println(info);
            pw.close();

        }catch(Exception e){
            throw AxisFault.makeFault(e);
        }
    }

    public static Document getDocument(String file) throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setIgnoringComments(true);

        DocumentBuilder builder = null;

        factory.setNamespaceAware(false);
        factory.setValidating(false);

        builder = factory.newDocumentBuilder();

        Document doc = builder.parse(file);
        return doc;
    }

    public static String getSystemRootPath(){
      String path = System.getProperty("starws.home");
      if(path != null){
        return path;
      }
      else return System.getProperty("user.dir");
    }


}
