package net.starmiddleware.starws2.transport.http.admin.deploy;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.util.Hashtable;
import org.apache.axis.AxisFault;
import org.apache.axis.description.OperationDesc;
import org.apache.axis.description.ServiceDesc;
import org.apache.axis.utils.*;
import java.util.*;
import javax.servlet.http.*;
import java.io.PrintWriter;
import java.io.IOException;
import org.apache.axis.enum.Style;
import java.util.Enumeration;
import org.omg.CORBA.*;
import org.apache.axis.i18n.Messages;


import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.DynamicAny.*;
import org.omg.CORBA.portable.*;


import net.starmiddleware.starws2.description.CORBAServiceDesc;

public class CORBAServiceDeploy implements ServiceDeploy{
  public CORBAServiceDeploy() {
  }
  CORBAServiceDesc desc=new CORBAServiceDesc(null);

  private String provider="Handler";
  private String namespace=null;
  private String scope=null;
  private String isStatic=null;
  private ORB orb=null;
  private org.omg.CORBA.Repository  repository = null;
  private String handler="net.starmiddleware.starws2.providers.corba.DynProvider";

  String ORBClass=null;

    String ORBSingletonClass=null;

    String RepositoryUrl=null;

    String InterfaceName=null;

    String CorbaUrl=null;



  Hashtable param=new Hashtable();


  public void setProvider(String in) {
    if (in != null) {
      if (in.equals("1")) {
        provider = "java:RPC";
      }
      else if(in.equals("2")){
         provider="java:MSG";
      }
    }
  }

  public String getProvider() {
    return provider;
  }

  public void setServiceName(String in) {
    if(in!=null)    desc.setName(in);
  }

  public String getName(){
    return desc.getName();
  }

  public void setClassName(String className) throws AxisFault {
    if(className!=null){
      if(desc.getImplInterface()!=null){
         if(!InterfaceName.equals(className))
           desc=new CORBAServiceDesc(null);
         else return;
      }
      desc.setProperty(CORBAServiceDesc.PROP_REPOSITORY ,repository) ;
      desc.loadServiceDescByIR(className);

       InterfaceName=className;
    }
  }
  public void setAllowedMethods(String methods){
    if(methods==null) return;
    if(!methods.equals("*")){
      ArrayList methodList = new ArrayList();
      StringTokenizer tokenizer = new StringTokenizer(methods, ",");
      while (tokenizer.hasMoreTokens()) {
        methodList.add(tokenizer.nextToken());
      }
      desc.setAllowedMethods(methodList);
    }

  }

  public void addNewParameter(String name,String value){
    if((name==null)||(value==null)) return;
    param.put(name,value);

  }
  public void removeParameter(String name){
    param.remove(name);
  }
  public String toString(boolean isDeploy){
     StringBuffer result=new StringBuffer();
     result.append("<service ");

     if(desc.getName()!=null){
        result.append("name=\""+desc.getName()+"\" ");
        result.append("provider=\""+provider+"\"");
     }
     result.append(">");
     String allowed="";
     if(desc.getAllowedMethods()!=null){
       for (int i = 0; i < desc.getAllowedMethods().size(); i++) {
         allowed += desc.getAllowedMethods().get(i);
         allowed += " ";
       }
     }
     if (!allowed.equals("")) {
         result.append("<parameter name=\"allowedMethods\" value=\"" + allowed +
                       "\"/>");
       }
     else{
       result.append("<parameter name=\"allowedMethods\" value=\"*\"/>");
     }
     if(desc.getImplClass()!=null){
       //result.append("<parameter name=\"className\" value=\""+desc.getImplClass().getName()+"\"/>");
       result.append(getMethods());
     }

     if(scope!=null){
       result.append("<parameter name=\"scope\" value=\""+scope+"\"/>");
     }
     if(CorbaUrl!=null){
       result.append("<parameter name=\"corbaUrl\" value=\""+CorbaUrl+"\"/>");
     }
     if(InterfaceName!=null){
       result.append("<parameter name=\"interfaceName\" value=\""+InterfaceName+"\"/>");
     }

     if(ORBClass!=null){
            result.append("<parameter name=\"ORBClass\" value=\""+ORBClass+"\"/>");
          }
     if(handler!=null){
                 result.append("<parameter name=\"handlerClass\" value=\""+handler+"\"/>");
               }

     if(ORBSingletonClass!=null){
            result.append("<parameter name=\"ORBSingletonClass\" value=\""+ORBSingletonClass+"\"/>");
      }
      if(RepositoryUrl!=null){
            result.append("<parameter name=\"repositoryUrl\" value=\""+RepositoryUrl+"\"/>");
      }



     if(isStatic!=null){
       result.append("<parameter name=\"isStatic\" value=\""+isStatic+"\"/>");
     }
     if(namespace!=null){
       result.append("<parameter name=\"namespace\" value=\""+namespace+"\"/>");
     }

     if(param.isEmpty()){
       if(!isDeploy){
        result.append("<parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/>");
       }
      }
     else{
       Enumeration enum=param.keys();
       while(enum.hasMoreElements()){
         String key=(String)enum.nextElement();
         result.append("<parameter name=\""+key+"\" value=\""+param.get(key)+"\"> </parameter>");
       }

     }
     result.append("</service>");
     return result.toString();

  }
  public void writeStep(HttpServletResponse response,String step){
        String xsltURI=null;
        if(step.equals("1")) xsltURI="../admin/CORBAService/addNewService1.xsl";
        else if(step.equals("2")) xsltURI="../admin/CORBAService/addNewService2.xsl";
        else if(step.equals("3")) xsltURI="../admin/CORBAService/serviceDetail.xsl";

       PrintWriter writer=null;
       try {
         writer = response.getWriter();
       }
       catch (IOException e) {
         return ;
       }
       response.setContentType("text/xml");

       writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
       writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                      "\"?>");
       writer.println("<deployment>");
       //writer.println("<service ><parameter/><parameter/><parameter/><parameter/></service>");
       writer.println(this.toString(false));

       writer.println("<action name=\"deployServiceStep\"></action>");
       writer.println("</deployment>");
       writer.close();


  }
  public void setStep(HttpServletRequest request, HttpServletResponse response,String step)
  throws Exception{
   try{
     if (step.equals("1")) {
       setStep1(request, response);
     }
     else if (step.equals("2")) {
       setStep2(request, response);
     }
     else if (step.equals("3")) {
       setStep3(request, response);
     }
   }catch(Exception e){
     throw e;
   }

  }
  private void setStep1(HttpServletRequest request, HttpServletResponse response)
  throws Exception{
    ORBClass=request.getParameter("ORBClass");
    if(ORBClass==null) throw new Exception("no ORB Class Name");
    ORBSingletonClass=request.getParameter("ORBSingletonClass");
    if(ORBSingletonClass==null) throw new Exception("no ORBSingleton Class Name");
    RepositoryUrl=request.getParameter("repositoryUrl");
    if(RepositoryUrl==null) throw new Exception("no repository ref Name");
    String tInterfaceName=request.getParameter("interfaceName");
    if(tInterfaceName==null) throw new Exception("no interface Name");
    CorbaUrl=request.getParameter("corbaUrl");
    if(CorbaUrl==null) throw new Exception("no CORBA Object'corbaUrl");


    try{
      if(orb==null)      orb = initORB(ORBClass, ORBSingletonClass);
    }catch(Exception e){
      throw new Exception("<strong><p>can not init ORB:</p></strong>"+e.getMessage());
    }
    try{
      repository = initRepository(RepositoryUrl);
      setClassName(tInterfaceName);

    }catch(Exception e){
      String msg=Messages.getMessage("initRepositoryError")+":"+e.getMessage();

      throw new Exception(msg);
    }

    setServiceName( (String) request.getParameter("name"));



  }
  private void setStep2(HttpServletRequest request, HttpServletResponse response){
    String[] methods=request.getParameterValues("methods");
    if(methods==null) return;
    ArrayList methodList = new ArrayList();
    for(int i=0;i<methods.length;i++){

      methodList.add(methods[i]);

    }
    desc.setAllowedMethods(methodList);

  }
  private void setStep3(HttpServletRequest request, HttpServletResponse response)
  throws Exception{
     try{
       setStep1(request, response);
     }catch(Exception e){
      throw e;
     }

     String methods=request.getParameter("allowedMethods");
     if(methods!=null){
       ArrayList methodList = new ArrayList();
       StringTokenizer token=new StringTokenizer(methods," ");
      while( token.hasMoreTokens()){

          methodList.add(token.nextToken());

       }
       if(methods.equals("*")){
          ArrayList list=desc.getOperations();
          for(int k=0;k<list.size();k++){
            methodList.add(((OperationDesc)list.get(k)).getName());
          }
       }
      desc.setAllowedMethods(methodList);
     }


     String tNamespace=request.getParameter("namespace");
     if(tNamespace!=null){
       if(!tNamespace.equals("")) namespace=tNamespace;
     }
     String tScope=request.getParameter("scope");
     if(!tScope.equals("request")) scope=tScope;



     String[] parameterNames=request.getParameterValues("parametername");
     String[] parameterValues=request.getParameterValues("parametervalue");
     if(parameterNames!=null){
       for (int i = 0; i < parameterNames.length; i++) {
         if (!parameterNames[i].equals(""))
           addNewParameter(parameterNames[i], parameterValues[i]);
       }
     }

  }
  public String getMethods(){
    ArrayList list=desc.getOperations();
    StringBuffer buffer=new StringBuffer();
    for(int i=0;i<list.size();i++){
       String name=((OperationDesc)list.get(i)).getName();
       if(isMethodAllowed(name))
         buffer.append("<method isSelected=\"true\" name=\""+name+"\"></method>");
       else   buffer.append("<method name=\""+name+"\"> </method>");
    }
    return buffer.toString();
  }

  private boolean isMethodAllowed(String name){
     List list=desc.getAllowedMethods();
     if(list==null) return false;
     for(int i=0;i<list.size();i++){
       if(list.get(i).equals(name)) return true;
     }
     return false;
  }

  private org.omg.CORBA.ORB  initORB(String orbcls,String orbsingletcls) throws AxisFault {
     org.omg.CORBA.ORB  orb = null;
     java.util.Properties props=null;
     try{
        props = System.getProperties();

        props.put("org.omg.CORBA.ORBClass", orbcls);
        props.put("org.omg.CORBA.ORBSingletonClass",orbsingletcls);


        String[] args = new String[1];
        args[0] = "";
        orb=(org.omg.CORBA.ORB)ORB.init(args,props);

         } catch(Exception e ) {
            throw new AxisFault(Messages.getMessage("init Orb Fail") );
        }


      return (org.omg.CORBA.ORB )orb;
    }
    private org.omg.CORBA.Repository  initRepository(String ir)throws AxisFault {

           org.omg.CORBA.Object obj = null;
           org.omg.CORBA.Repository rep = null;

          if ((orb == null) || (ir == null))
                return null;


           try
           {
            obj = orb.string_to_object(ir);
            rep = org.omg.CORBA.RepositoryHelper.narrow(obj);
            }catch(Exception e ){
             // System.err.println("error occur in resolve Repository IOR");
              throw new AxisFault( Messages.getMessage("noInfRepository") );
            }


          return rep;
      }

}
