package net.starmiddleware.starws2.transport.http.admin;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;
import javax.servlet.ServletException;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import org.apache.axis.AxisFault;
import org.apache.axis.i18n.Messages;

public class javaServiceAdmin {
  public javaServiceAdmin() {
  }

  public void process(HttpServletRequest request, HttpServletResponse response,
                      AdminService admin, String command) {

    if (command.equals("javaServiceList")) {
      getServiceList(request, response, admin);
    }
    else if (command.equals("javaServiceDetail")) {
      getServiceDetail(request, response, admin);
    }
    else if (command.equals("javaShowServiceModify")) {
      showModifyJavaService(request, response, admin);
    }
    else if (command.equals("javaServiceModify")) {
      modifyJavaService(request, response, admin);
    }

  }

  public String modifyService(HttpServletRequest request,
                              HttpServletResponse response) {

    return "ok";

  }

  void getServiceList(HttpServletRequest request, HttpServletResponse response,
                      AdminService admin) {

    NodeList nodeList = admin.getDeloymentInfo(request, response, "service");

    if (nodeList != null) {
      Vector service = new Vector();
      for (int i = 0; i < nodeList.getLength(); i++) {
        Element e = (Element) nodeList.item(i);
        String name = e.getAttribute("name");
        String provider = e.getAttribute("provider");

        //
        //java services
        //
        if (provider.startsWith("java")) {
          service.add(name);
          service.add(provider);
          service.add("javaServiceDetail");

        }
        else if (provider.equals("Handler")) {

          NodeList nodeList2 = e.getElementsByTagName("parameter");
          boolean bHandlerClass = false;
          for (int j = 0; j < nodeList2.getLength(); j++) {
            Element e2 = (Element) nodeList2.item(j);
            String name2 = e2.getAttribute("name");
            if (name2.equals("handlerClass")) {
              bHandlerClass = true;
              provider = e2.getAttribute("value");
              break;
            }
          }

          //
          //corba services
          //
          if (bHandlerClass) {
            if (provider.equals(
                "net.starmiddleware.starws2.providers.corba.DynProvider")) {
              service.add(name);
              service.add("Corba:RPC");
              service.add("corbaServiceDetail");

            }

            else if (provider.equals(
                "net.starmiddleware.starws2.providers.ccm.CCMProvider")) {
              service.add(name);
              service.add("CCM:RPC");
              service.add("ccmServiceDetail");

            }

            //
            //jms services
            //
            else if (provider.equals(
                "net.starmiddleware.starws2.providers.jms.JMSProvider")) {
              service.add(name);
              service.add("JMS:RPC");
              service.add("jmsServiceDetail");

            }
            else {

            }
          }

        }
        else {

        }

      }

      //
      //sort the deployed services by alphabet
      //
      String swap = null;
      for (int i = 0; i < service.size(); i += 3) {
        for (int j = 0; j < service.size() - 4; j += 3) {
          String sj = (String) service.get(j);
          String sjj = (String) service.get(j + 3);
          if (sj.toLowerCase().compareTo(sjj.toLowerCase())>0) {
            for (int k = 0; k < 3; k++) {
              swap = (String) service.get(j + k);
              service.set(j + k, service.get(j + k + 3));
              service.set(j + k + 3, swap);

            }
          }
        }
      }
      request.setAttribute("service", service);
    }

    try {

      request.getRequestDispatcher("../admin/service.jsp").forward(request,
          response);

    }
    catch (java.io.IOException e) {

    }
    catch (javax.servlet.ServletException e) {

    }
    return;

  }

  void getServiceDetail(HttpServletRequest request,
                        HttpServletResponse response, AdminService admin) {
    admin.getServiceDetail(request, response,
                           "../admin/javaService/serviceDetail.jsp");
  }

  void showModifyJavaService(HttpServletRequest request,
                             HttpServletResponse response, AdminService admin) {
    admin.getServiceDetail(request, response,
                           "../admin/javaService/modifyService.jsp");

  }

  public void modifyJavaService(HttpServletRequest request,
                                HttpServletResponse response,
                                AdminService admin) {
    StringBuffer buffer = new StringBuffer();
    String serviceName = request.getParameter("name");
    String provider = request.getParameter("provider");
    String style = request.getParameter("style");
    buffer.append("<service name=\"" + serviceName + "\" provider=\"" +
                  provider + "\" style=\"" + style + "\">");
    Enumeration param = request.getParameterNames();
    while (param.hasMoreElements()) {
      String name = (String) param.nextElement();
      if ( (!name.equals("name")) && (!name.equals("provider")) &&
          (!name.equals("cmd")) && (!name.equals("style")) &&
          (!name.equals("location"))) {
        buffer.append("<parameter name=\"" + name + "\" value=\"" +
                      request.getParameter(name) + "\"/>");
      }
    }

    buffer.append(" </service>");

    try {
      String body = null;
      body = "<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +
          buffer.toString() + "</deployment>";

      Object msgContext = admin.invokeAdmin(request, response, body);
      if (msgContext != null) {

        request.setAttribute("info", serviceName +Messages.getMessage("serviceModifySuccess"));
        request.getRequestDispatcher(admin.getInfoPage()).forward(request,
            response);

      }
    }
    catch (AxisFault e) {

    }
    catch (ServletException e2) {

    }
    catch (IOException e2) {

    }

  }

}
