package net.starmiddleware.starws2.transport.http.admin;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

//by zhoubin to disable UDDI. import net.starmiddleware.starws2.transport.http.admin.uddi.RequestForward;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.apache.axis.*;
import org.w3c.dom.*;
import net.starmiddleware.starws2.security.rbac.*;

/***************    zm   ****************/

public class securityAdmin {

  public securityAdmin() {
  }

  public void process(HttpServletRequest request,
                      HttpServletResponse response, AdminService admin,
                      String cmd) throws ServletException, IOException {

    if (cmd.equals("RBAC")) {
      request.getRequestDispatcher("../admin/RBAC/rbac.jsp").forward(
          request,
          response);
      return;
    }

    else if (cmd.equals("RBACListAllUsers")) {
      listAllUsers(request, response, admin);
    }
    else if (cmd.equals("RBACListAllRoles")) {
      listAllRoles(request, response, admin);
    }
    else if (cmd.equals("RBACListAssignedRoles")) {
      listAssignedRoles(request, response, admin);
    }
    else if (cmd.equals("RBACAddUser")) {
      addUser(request, response, admin);
    }
    else if (cmd.equals("RBACDeleteUser")) {
      deleteUser(request, response, admin);
    }
    else if (cmd.equals("RBACAssignRole")) {
      assignRole(request, response, admin);
    }
    else if (cmd.equals("RBACDeassignRole")) {
      deassignRole(request, response, admin);
    }
    else if (cmd.equals("RBACAddRole")) {
      addRole(request, response, admin);
    }
    else if (cmd.equals("RBACDeleteRole")) {
      deleteRole(request, response, admin);
    }
    else if (cmd.equals("RBACAssignPermission")) {
      assignPermission(request, response, admin);
    }
    else if (cmd.equals("RBACDeassignPermission")) {
      deassignPermission(request, response, admin);
    }

    else if (cmd.equals("RBACListAssignedPermissions")) {
      listAssignedPermissions(request, response, admin);
    }

  }

  void listAllUsers(HttpServletRequest request, HttpServletResponse response,
                    AdminService admin) throws ServletException {
    try {
      NodeList users = UserManager.listAllUsers();
      if (users != null) {
        admin.writerOutWithNodeList(response, users,
                                    "../admin/RBAC/listUsers.xslt");
      }
    }
    catch (AxisFault f) {
      return;
    }
  }

  void listAssignedRoles(HttpServletRequest request,
                         HttpServletResponse response, AdminService admin) throws
      ServletException {
    try {
      String user = request.getParameter("user");
      Node role = UserManager.listAssignedRoles(user);
      if (role != null) {
        admin.writerOutWithNode(response, role,
                                "../admin/RBAC/listAssignedRoles.xslt");
      }
    }
    catch (AxisFault f) {
      return;
    }

  }

  void listAllRoles(HttpServletRequest request, HttpServletResponse response,
                    AdminService admin) throws ServletException {
    try {
      NodeList roles = RoleManager.listAllRoles();
      if (roles != null) {
        admin.writerOutWithNodeList(response, roles,
                                    "../admin/RBAC/listRoles.xslt");
      }
    }
    catch (AxisFault f) {
      return;
    }
  }

  void addUser(HttpServletRequest request, HttpServletResponse response,
               AdminService admin) {
    try {
      String user = request.getParameter("user");
      String result = UserManager.addUser(user);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void deleteUser(HttpServletRequest request, HttpServletResponse response,
                  AdminService admin) {
    try {
      String user = request.getParameter("user");
      String result = UserManager.deleteUser(user);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void assignRole(HttpServletRequest request, HttpServletResponse response,
                  AdminService admin) {
    try {
      String user = request.getParameter("user");
      String role = request.getParameter("role");
      String result = UserManager.assignRole(user, role);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void deassignRole(HttpServletRequest request, HttpServletResponse response,
                    AdminService admin) {
    try {
      String user = request.getParameter("user");
      String role = request.getParameter("role");
      String result = UserManager.deassignRole(user, role);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void addRole(HttpServletRequest request, HttpServletResponse response,
               AdminService admin) {
    try {
      String role = request.getParameter("role");
      String result = RoleManager.addRole(role);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void deleteRole(HttpServletRequest request, HttpServletResponse response,
                  AdminService admin) {
    try {
      String role = request.getParameter("role");
      String result = RoleManager.deleteRole(role);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void assignPermission(HttpServletRequest request,
                        HttpServletResponse response, AdminService admin) {
    try {
      String role = request.getParameter("role");
      String service = request.getParameter("service");
      String method = request.getParameter("method");
      String result = PermissionManager.assignPermission(role, service,
          method);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }
  }

  void deassignPermission(HttpServletRequest request,
                          HttpServletResponse response, AdminService admin) {
    try {
      String role = request.getParameter("role");
      String service = request.getParameter("service");
      String method = request.getParameter("method");
      String result = PermissionManager.deassignPermission(role, service,
          method);
      StringBuffer buffer = new StringBuffer();
      buffer.append(result);
      request.setAttribute("info", buffer);
      request.getRequestDispatcher(admin.getInfoPage()).forward(request,
          response);
      return;
    }
    catch (Exception e) {
      return;
    }

  }

  void listAssignedPermissions(HttpServletRequest request,
                               HttpServletResponse response,
                               AdminService admin) {
    try {
      String role = request.getParameter("role");
      if (RoleManager.contains(role)) {
        Node permission = PermissionManager.listAssignedPermissions(role);
        if (role != null) {
          admin.writerOutWithNode(response, permission,
                                  "../admin/RBAC/listAssignedPermissions.xslt");
        }
      }
      else {
        StringBuffer buffer = new StringBuffer();
        buffer.append("The role does not exists. Please add it first.");
        request.setAttribute("info", buffer);
        request.getRequestDispatcher(admin.getInfoPage()).forward(request,
            response);
        return;
      }
    }
    catch (Exception e) {
      return;
    }
  }
  /***************    zm   ****************/

}
