package testofsws2.testPrimitive;

/**
 * <p>Title: testofSWS2</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import org.apache.axis.types.*;
import org.omg.www.*;

public class StubUsage {
  public static void main(String [] args) throws Exception{
        // Make a service
        PrimitiveService service = new PrimitiveServiceLocator();

        // Now use the service to get a stub which implements the SDI.
        Primitive port = service.getprimitive(new java.net.URL("http://localhost:8080/starwebservice/services/urn:corba-primitive"));

        // Make the actual call

        //test Boolean
       boolean nameb=true;
       boolean echonameb=port.echoBoolean(nameb);
       if (echonameb==nameb)
         System.out.println("test of Boolean is ok");

       //test Char
       _char namec=new _char();
       namec.setValue("a");
       if (port.echoChar(namec).getValue().equals("a"))
       System.out.println("test of Char is ok");

       //test Wchar
        Wchar namewc=new Wchar("");
        if (port.echoWChar(namewc).getValue().equals(""))
          System.out.println("test of Wchar is ok");

        //test Double
        double named=3.1437;
        double echonamed=port.echoDouble(named);
        if (echonamed==named)
          System.out.println("test of Double is ok");

        //test Float
        float namef=3.1415926f;
        float echonamef=port.echoFloat(namef);
        if (echonamef==namef)
          System.out.println("test of Float is ok");

        //test Octet
        UnsignedByte nameo=new UnsignedByte();
        long ssValue=77L;
        nameo.setValue(ssValue);
        if (ssValue==port.echoOctet(nameo).byteValue())
          System.out.println("test of Octet is ok");

        //test Long
        int namei=-34;
        int echonamei=port.echoLong(namei);
        if (echonamei==namei)
          System.out.println("test of Long is ok");

        //test LongLong
        long namel=-78L;
        long echonamel=port.echoLongLong(namel);
        if (echonamel==namel)
          System.out.println("test of LongLong is ok");

        //test Short
        short namesh=-327;
        short echonamesh=port.echoShort(namesh);
        if (echonamesh==namesh)
          System.out.println("test of Short is ok");

        //test String
        String names=new String("haha");
        if (port.echoString(names).equals("haha"))
          System.out.println("test of String is ok");

        //test WString
        String namews=new String("whaha");
        if (port.echoWString(namews).equals("whaha"))
          System.out.println("test of WString is ok");

        //test UnsignedShort
        long sValue=78L;
        UnsignedShort nameush=new UnsignedShort(sValue);
        if(sValue==port.echouShort(nameush).longValue())
          System.out.println("test of UnsignedShort is ok");

        //test UnsignedLong
        int iValue=788;
        UnsignedInt nameui=new UnsignedInt(iValue);
        if(iValue==port.echouLong(nameui).intValue())
          System.out.println("test of UnsignedLong is ok");

        //test UnsignedLongLong
        double lValue=55;
        UnsignedLong nameul=new UnsignedLong(lValue);
        if((long) lValue==port.echouLongLong(nameul).longValue())
          System.out.println("test of UnsignedLongLong is ok");
    }


}
