<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XMLSPY v5 rel. 4 U (http://www.xmlspy.com) by rth77 (rth77) -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="iterate">
		<xsl:param name="times" select="0"/>
		<xsl:if test="$times>0">
			<tr>
				<td>
					<input name="parametername" type="text">
						<xsl:attribute name="id"/>
						<xsl:attribute name="value"/>
					</input>
				</td>
				<td>
					<input name="parametervalue" type="text" size="50">
						<xsl:attribute name="value"/>
					</input>
				</td>
			</tr>
			<xsl:call-template name="iterate">
				<xsl:with-param name="times" select="$times-1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<xsl:template match="/">
		<html>
			<head>
				<meta http-equiv="Content-Type" content="text/html; charset=gb2312"/>
				<title>add new service</title>
				<script language="JavaScript" type="text/JavaScript">
				   
					function MM_callJS(jsStr) { 
	  return eval(jsStr)
	}
	function returnServiceDetail(){
	  document.returnForm.submit();
	}
	
	function OnAddSubmit(){ 

            document.addForm.content.value="&lt;service  name=\&quot;"+"<xsl:for-each select="deployment/service">
						<xsl:value-of select="@name"/>
					</xsl:for-each>"+"\&quot;  "+"provider=\&quot;"+"<xsl:for-each select="deployment/service">
						<xsl:value-of select="@provider"/>
					</xsl:for-each>"+"\&quot;&gt;";             
					
                  <xsl:for-each select="deployment/service/parameter">					
							document.addForm.content.value+= "&lt;parameter name=\&quot;" + "<xsl:value-of select="@name"/>" + "\&quot; value=\&quot;" + "<xsl:value-of select="@value"/>" +"\&quot;/&gt;"; 
                  </xsl:for-each>
                  
					          for(i=1;ilt;5;i++){ 
							 if( document.service.parametername.value!="")
           document.addForm.content.value+= "&lt;parameter name=\&quot;" + document.service.parametername.value + "\&quot; value=\&quot;" + document.service.parametervalue.value +"\&quot;/&gt;";
                      }
                 
                       
					<xsl:for-each select="deployment/service/namespace">
						<xsl:if test=".!=' ' ">
					               document.addForm.content.value+= "&lt;namespace&gt;" + "<xsl:value-of select="."/>"+"&lt;/namespace&gt;" 
					  </xsl:if>
					</xsl:for-each>						
              
                            
            document.addForm.content.value+="&lt;/service&gt;";
	    document.addForm.submit();
	}
				</script>
			</head>
			<body>
				<form action="" method="post" name="service">
					<table width="90%" border="0" cellpadding="1" cellspacing="1">
						<xsl:for-each select="deployment">
							<xsl:for-each select="service">
								<tr>
									<td width="16%">service name:</td>
									<td width="84%">
										<xsl:value-of select="@name"/>
									</td>
								</tr>
								<tr>
									<td>provider:</td>
									<td>
										<xsl:value-of select="@provider"/>
									</td>
								</tr>
								<tr>
									<td>style:</td>
									<td>
										<xsl:value-of select="@style"/>
									</td>
								</tr>
								<tr>
									<td>namespace:</td>
									<td>
										<xsl:for-each select="namespace">
											<xsl:value-of select="."/>
										</xsl:for-each>
									</td>
								</tr>
								<tr>
									<td>allowedMethods:</td>
									<td>
										<xsl:for-each select="parameter">
											<xsl:if test="@name[.='allowedMethods']">
												<xsl:value-of select="@value"/>
											</xsl:if>
										</xsl:for-each>
									</td>
								</tr>
								<tr>
									<td>className:</td>
									<td>
										<xsl:for-each select="parameter">
											<xsl:if test="@name[.='className']">
												<xsl:value-of select="@value"/>
											</xsl:if>
										</xsl:for-each>
									</td>
								</tr>
								<tr>
									<td>scope:</td>
									<td>
										<xsl:for-each select="parameter">
											<xsl:if test="@name[.='scope']">
												<xsl:value-of select="@value"/>
											</xsl:if>
										</xsl:for-each>
									</td>
								</tr>
								<tr>
									<td>isStatic:</td>
									<td>
										<xsl:for-each select="parameter">
											<xsl:if test="@name[.='isStatic']">
												<xsl:value-of select="@value"/>
											</xsl:if>
										</xsl:for-each>
									</td>
								</tr>
							</xsl:for-each>
						</xsl:for-each>
						<tr>
							<td colspan="2">
								<hr/>
							</td>
						</tr>
						<tr>
							<td>parameters:</td>
							<td>
								<table width="100%" border="1" cellpadding="0" cellspacing="0">
									<tr>
										<td width="31%" align="center">name</td>
										<td width="69%" align="center">value</td>
									</tr>
									<xsl:call-template name="iterate">
										<xsl:with-param name="times" select="4"/>
									</xsl:call-template>
								</table>
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<hr/>
							</td>
						</tr>
						<tr align="center">
							<td colspan="2">
								<input name="Submit" type="button" onClick="MM_callJS('OnAddSubmit()')" value="confirm"/>
								<input name="Submit" type="button" onClick="MM_callJS('returnServiceDetail()')" value="return"/>
							</td>
						</tr>
					</table>
				</form>
				<form action="" method="post" name="addForm" id="addForm">
					<xsl:for-each select="deployment">
						<xsl:for-each select="action">
							<xsl:attribute name="action">../servlet/AdminServlet?cmd=<xsl:value-of select="@name"/><xsl:if test="@name[.='modifyJavaService']">&amp;serviceName=<xsl:value-of select="../service[@name]"/></xsl:if></xsl:attribute>
						</xsl:for-each>
					</xsl:for-each>
					<input name="content" type="hidden" id="content"/>
				</form>
				<form method="post" name="returnForm" id="returnForm">
					<xsl:for-each select="deployment">
						<xsl:for-each select="service">
							<xsl:attribute name="action">../servlet/AdminServlet?cmd=getJavaServiceDetail&amp;serviceName=<xsl:value-of select="@name"/></xsl:attribute>
						</xsl:for-each>
					</xsl:for-each>
					<input name="content" type="hidden" id="content"/>
				</form>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
