<?xml version="1.0" encoding="gb2312"?>
<!-- edited with XMLSPY v5 rel. 4 U (http://www.xmlspy.com) by ttdown (ttdown) -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:template match="/">
		<html>
			<head/>
			<body>
				<xsl:for-each select="deployment">
					<xsl:for-each select="service">
						<!-- show service name -->
						<font size="+2">ƣ</font>
						<xsl:value-of select="@name"/>
						<br/>
						<ul>
							<li>
								<font size="+1">÷ʽ</font>
								<xsl:value-of select="@provider"/>
							</li>
							<li>
								<font size="+1">style :</font>
								<xsl:choose>
									<xsl:when test="@style[.='']">rpc</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="@style"/>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:value-of select="@style"/>
							</li>
							<xsl:for-each select="namespace">
								<li>
									<font size="+1">namespace :</font>
								</li>
								<xsl:value-of select="."/>
							</xsl:for-each>
							<!-- show server parameter -->
							<li>
								<font size="+1">parameter :</font>
							</li>
							<table width="90%" border="1" cellpadding="0" cellspacing="0">
								<tr>
									<td align="center">
										<font size="+1">name</font>
									</td>
									<td align="center">
										<font size="+1">value</font>
									</td>
								</tr>
								<xsl:for-each select="parameter">
									<tr>
										<td>
											<xsl:for-each select="@name">
												<xsl:value-of select="."/>
											</xsl:for-each>
										</td>
										<td>
											<xsl:for-each select="@value">
												<xsl:value-of select="."/>
											</xsl:for-each>
										</td>
									</tr>
								</xsl:for-each>
							</table>
						</ul>
						<hr/>
					</xsl:for-each>
				</xsl:for-each>
				<table width="75%" border="0">
					<tr>
						<td>
							<img src="../admin/image/dot.jpg">
								<A>
									<xsl:for-each select="deployment">
										<xsl:for-each select="service">
											<xsl:attribute name="href">../admin/addNewParameter.jsp?serviceName=<xsl:value-of select="@name"/></xsl:attribute>
										</xsl:for-each>
									</xsl:for-each>                    
                     add parameter
                  </A>
							</img>
						</td>
						<td>
							<img src="../admin/image/dot.jpg">
								<A>
									<xsl:for-each select="deployment">
										<xsl:for-each select="service">
											<xsl:attribute name="href">../servlet/AdminServlet?cmd=showModifyJavaService&amp;serviceName=<xsl:value-of select="@name"/></xsl:attribute>
										</xsl:for-each>
									</xsl:for-each>                    
                     modifyService
                  </A>
							</img>
						</td>
						<td>
							<img src="../admin/image/dot.jpg">
								<A>
									<xsl:for-each select="deployment">
										<xsl:for-each select="service">
											<xsl:attribute name="href">../servlet/AdminServlet?cmd=undeployService&amp;serviceName=<xsl:value-of select="@name"/></xsl:attribute>
										</xsl:for-each>
									</xsl:for-each>                    
                     undeployService
                  </A>
							</img>
						</td>
						<td>
							<img src="../admin/image/dot.jpg">
								<A>
									<xsl:for-each select="deployment">
										<xsl:for-each select="service">
											<xsl:attribute name="href">../services/<xsl:value-of select="@name"/>?wsdl</xsl:attribute>
										</xsl:for-each>
									</xsl:for-each>                    
                     show WSDL
                  </A>
							</img>
						</td>
						<td>
							<img src="../admin/image/dot.jpg">
								<A>
									<xsl:for-each select="deployment">
										<xsl:for-each select="service">
											<xsl:attribute name="href">../servlet/AdminServlet?cmd=getService</xsl:attribute>
										</xsl:for-each>
									</xsl:for-each>                    
                     return service list
                  </A>
							</img>
						</td>
					</tr>
				</table>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
