package net.starmiddleware.starws2.I2WCFE.idl;

/**
 * @author Gerald Brose
 * @version $Id: Fixed.java,v 1.1 2004/07/13 02:13:54 jane Exp $
 */

class FixedType
    extends BaseType
{

    public FixedType( int num )
    {
        super( num );
    }

    public String typeName()
    {
        return "fixed";
    }

    public TypeSpec typeSpec()
    {
        return this;
    }

    public boolean basic()
    {
        return true;
    }

    public int getTCKind()
    {
        return 6;
    }

    public String toString()
    {
        return typeName();
    }

    public String holderName()
    {
        return "org.omg.CORBA.FixedHolder";
    }

    public String printReadExpression( String strname )
    {
        return strname + ".read_fixed()";
    }

    public String printWriteStatement( String var_name, String strname )
    {
        return strname + ".write_fixed(" + var_name + ");";
    }

    public String printInsertExpression()
    {
        return "insert_fixed";
    }

    public String printExtractExpression()
    {
        return "extract_fixed";
    }
}


