package net.starmiddleware.starws2.encoding;

/**
 * <p>Title:deserialization for complextypes based on array</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author shuchao
 * @version 1.0
 */
import java.util.*;
import javax.xml.namespace.*;

import org.apache.axis.encoding.*;
import org.apache.axis.message.*;
import org.apache.axis.utils.*;
import org.xml.sax.*;
import net.starmiddleware.starws2.encoding.java.*;

public class ArrayBaseTypeDes
    extends DeserializerImpl {

  ArrayList arrayValue = new ArrayList();

  DeserializerImpl currentHandler = null;

  Class arrayBaseObject = null;
  public ArrayBaseTypeDes(String ObjectName) {
    try {
      arrayBaseObject = Class.forName(ObjectName);

    }
    catch (Exception e) {

    }
  }

  public SOAPHandler onStartChild(String namespace,
                                  String localName,
                                  String prefix,
                                  Attributes attributes,
                                  DeserializationContext context) throws
      SAXException {
    QName type = context.getTypeFromAttributes(namespace,
                                               localName,
                                               attributes);

    if (type == null) {
      MessageElement curEl = context.getCurElement();
      type = curEl.getType();
      if (type == null) {
        type = this.defaultType;
      }
      if (type == null) {
        return null;
      }

    }

    if (log.isDebugEnabled()) {
      log.debug(Messages.getMessage("gotType00", "Deser", "" + type));
    }

    if (type != null) {

      Deserializer dser = (Deserializer) context.getDeserializerForType(type);
      if (dser != null) {
        currentHandler = (DeserializerImpl) dser;
      }
      else {
        throw new SAXException(
            Messages.getMessage("noDeser00", "" + type));
      }

    }

    return (SOAPHandler) currentHandler;

  }

  /**
   * @param namespace
   * @param localName
   * @param context
   * @throws SAXException
   */
  public void onEndChild(String namespace, String localName,
                         DeserializationContext context) throws SAXException {

    if (currentHandler != null)
      arrayValue.add(currentHandler.getValue());
  }

  /**
   * @param namespace
   * @param localName
   * @param context
   * @throws SAXException
   */
  public void onEndElement(String namespace, String localName,
                           DeserializationContext context) throws SAXException {

    Object realValue = null;
    if (arrayValue.size() > 0) {
      Object t = arrayValue.get(0);
      Class cls = t.getClass();
      try {

        realValue = java.lang.reflect.Array.newInstance(cls, arrayValue.size());
        for (int i = 0; i < arrayValue.size(); i++) {
          java.lang.reflect.Array.set(realValue, i, arrayValue.get(i));
        }

        if (arrayBaseObject != null) {
          Class[] formalArgs = new Class[] {
              Object.class};
          Object instance = arrayBaseObject.newInstance();

          ( (ArrayBaseType) instance).setValue(realValue);
          value = instance;
        }

      }
      catch (Exception e) {

      }

    }

  }

}
