package net.starmiddleware.starws2.encoding.CORBA;

/**
 * <p>Title:System-used middle type, recording the middle states
 * of serialization and deserialization</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author:shuchao
 * @version 1.0
 */
import java.util.ArrayList;
import javax.xml.namespace.QName;

public class ComplexType implements typeAbstract {
  //
  boolean hasChild=false;
  //
  String value=null;
  //record all data
  ArrayList child=new ArrayList();

  String namePrefix="";

  QName type=null;

  String  namePostfix="";

  boolean isSpecialName=false;

  String parentName="";

  public ComplexType() {
  }
  public Object getValue(){
    return value;
  }
  public void setValue(String value){
    hasChild=false;
    this.value=value;
  }
  public ArrayList getChild(){
    return child;
  }

  public void add(Object o,String name){
    hasChild=true;
    child.add(o);
    child.add(name);
  }


  public void add(Object o){
    hasChild=true;
    child.add(o);
    child.add("");
  }

  public void setNamePrefix(String name){
    this.namePrefix=name;
  }

  public String getName(){
    if((isSpecialName)&&(!namePrefix.equals("")))
       return parentName+"."+namePrefix+"_"+namePostfix;
    else
       return namePostfix;
  }
  public void setType(QName type){
    this.type=type;
  }
  public QName getType(){
    return type;
  }
  public String getValueNamespace(){

      return type.getLocalPart()+"."+this.getName();
  }
  public boolean hasChilds(){
    return hasChild;
  }
  public void init(){
    value=null;
    hasChild=false;
    type=null;
    child.clear();
  }
  public void setNamePostfix(String name){
    this.namePostfix=name;
  }
  public String getNamePostfix( ){
   return this.namePostfix;
 }

  public String getNamePrefix(){
    return this.namePrefix;
  }

  public void addNamePrefix(String preFix){
     this.namePrefix=preFix+this.namePrefix;
  }

  public void addNamePostfix(String postFix){
     this.namePostfix=this.namePostfix+postFix;
  }

  public void setSpecialName(boolean isSpecailName){
    this.isSpecialName=isSpecailName;
  }

  public boolean isSpecialName(){
   return isSpecialName;
  }


  public void setParentName(String parentName){
     this.parentName=parentName;
  }

  public String getParentName( ){
       return this.parentName;
    }

}
