package net.starmiddleware.starws2.encoding;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.util.*;
import javax.xml.namespace.*;

import org.apache.axis.encoding.*;
import org.apache.axis.utils.*;
import org.xml.sax.*;

public class CharacterDesr
    extends DeserializerImpl {

  public static final QName myTypeQName = new QName(
      "http://http://www.omg.org/IDL-Mapped/", "char");

  private Hashtable typesByMemberName = new Hashtable();

  private StringBuffer charValue = new StringBuffer();
  public CharacterDesr() {
    typesByMemberName.put("char", "character");

  }

  /**
   * Append any characters received to the value.  This method is defined
   * by Deserializer.
   */
  public void characters(char[] chars, int start, int end) throws SAXException {
    charValue.append(chars, start, end);
  }

  public void onEndElement(String namespace, String localName,
                           DeserializationContext context) throws SAXException {
    if (isNil || charValue == null) {
      value = null;
      return;
    }
    if (charValue.length() > 1) {

      throw new SAXException(
          Messages.getMessage("unregistered00", "character"));

    }
    value = new Character(charValue.toString().charAt(0));
  }

  /**
   * Reset deserializer for re-use
   */
  public void reset() {
    charValue.setLength(0); // Reset string buffer back to zero

    isNil = false; // Don't know if nil
    isEnded = false; // Indicate the end of element not yet called
  }

}
