package net.starmiddleware.starws2.security.rbac;

import java.io.*;
import java.security.*;
import java.security.cert.*;
import java.util.*;
import java.math.*;
import sun.security.x509.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */


public class CheckCertSign {


  private static java.security.cert.Certificate getCACertificateInstance(String
      CACertificateFile) throws Exception {
    //if(caCertificate == null){
    java.security.cert.Certificate caCertificate = null;
    CertificateFactory cf = CertificateFactory.getInstance("X.509");
    FileInputStream in = new FileInputStream(CACertificateFile);
    caCertificate = cf.generateCertificate(in);
    in.close();
    // }
    return caCertificate;
  }

  static public boolean verify(java.security.cert.Certificate cert,
                               String CACertificateFile) throws Exception {
    java.security.cert.Certificate caCertificate = getCACertificateInstance(
        CACertificateFile);
    boolean isValid = false;
    PublicKey pbk = caCertificate.getPublicKey();
    try {
      cert.verify(pbk);
      isValid = true;
    }
    catch (Exception e) {
      isValid = false;
      System.out.println(e);
    }
    return isValid;
  }

  public static void main(String[] args) throws Exception {
    String root = "root.cer";
    String ca_signed = "ca_signed.cer";

    CertificateFactory cf = CertificateFactory.getInstance("X.509");
    FileInputStream in = new FileInputStream(root);
    java.security.cert.Certificate cac = cf.generateCertificate(in);
    in.close();

    FileInputStream input = new FileInputStream(ca_signed);
    java.security.cert.Certificate test = cf.generateCertificate(input);
    input.close();
    PublicKey pbk = cac.getPublicKey();
    test.verify(pbk);
  }
}
