package net.starmiddleware.starws2.security.rbac;

import org.apache.axis.handlers.BasicHandler;
import org.apache.axis.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.*;
import java.io.*;
import org.apache.axis.utils.XMLUtils;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */

public class UserPasswordAuthHandler extends BasicHandler {

  private static String USER_PASSWORD_FILE = RBACUtil.getSystemRootPath() +
      //System.getProperty("user.dir") +
       "//conf/security/rbac/user-password.xml";

    public void invoke(MessageContext msgContext) throws org.apache.axis.AxisFault {
        /**@todo Implement this org.apache.axis.Handler abstract method*/
        String user = msgContext.getUsername();
        String password = msgContext.getPassword();
        if(!validatePassword(user,password))
            throw new AxisFault("UserPasswordAuthHandler", "password not valid", null, null);

    }

    private static boolean validatePassword(String user, String password) throws AxisFault{
        try {
            Document doc = RBACUtil.getDocument(USER_PASSWORD_FILE);
            NodeList userNodeList = doc.getElementsByTagName("user");
            if (userNodeList!= null){
                for (int i = 0; i < userNodeList.getLength(); i++) {
                    Element userElement = (Element) userNodeList.item(i);
                    if (userElement.getAttribute("name").equals(user)) {
                        if(userElement.getAttribute("password").equals(password))
                            return true ;
                    }
                }
            }
            return false;
        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static String getPassword(String user)throws AxisFault{
        try {
            Document doc = RBACUtil.getDocument(USER_PASSWORD_FILE);
            NodeList userNodeList = doc.getElementsByTagName("user");
            String password = null;
            if (userNodeList!= null){
                for (int i = 0; i < userNodeList.getLength(); i++) {
                    Element userElement = (Element) userNodeList.item(i);
                    if (userElement.getAttribute("name").equals(user)) {
                        password = userElement.getAttribute("password");
                    }
                }
            }
            return password;
        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static String modifyPassword(String user, String newPassword)throws AxisFault{
        try {
            Document doc = RBACUtil.getDocument(USER_PASSWORD_FILE);
            NodeList userNodeList = doc.getElementsByTagName("user");
            if (userNodeList!= null){
                for (int i = 0; i < userNodeList.getLength(); i++) {
                    Element userElement = (Element) userNodeList.item(i);
                    if (userElement.getAttribute("name").equals(user)) {
                        userElement.setAttribute("password", newPassword);
                    }
                }
            }
            return "you hava modified the user's password successfully.";
        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static void main(String[] args) {
    }
}
