package net.starmiddleware.starws2.transport.http.admin;

import org.apache.axis.transport.http.*;
import java.io.IOException;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.http.HttpServletResponse;
import javax.xml.soap.SOAPException;

import org.apache.axis.Constants;
import org.apache.axis.Message;
import javax.xml.soap.SOAPBody;

import org.apache.axis.server.AxisServer;
import org.apache.axis.MessageContext;
import org.apache.axis.AxisEngine;
import org.apache.axis.utils.JavaUtils;
import org.apache.axis.utils.Messages;
import org.apache.axis.AxisFault;
import org.apache.axis.components.logger.LogFactory;
import org.apache.axis.utils.XMLUtils;
import org.apache.commons.logging.Log;


import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import org.apache.xerces.dom.DeepNodeListImpl;
import org.apache.axis.Handler;
import java.io.*;
import org.apache.axis.SimpleTargetedChain;
import org.apache.axis.SimpleChain;
//by zhoubin to disable UDDI. import net.starmiddleware.starws2.transport.http.admin.uddi.RequestForward;
import net.starmiddleware.starws2.transport.http.admin.deploy.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Enumeration;
import org.apache.axis.handlers.soap.SOAPService;
import org.apache.axis.transport.http.AxisServlet;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class AdminService
    extends AxisServletBase {

  private String infoPage = "../admin/info.jsp";

  public AxisServer server = null;

  globalAdmin global = new globalAdmin();

  javaServiceAdmin javaService = new javaServiceAdmin();

  //added by zk
  JMSServiceAdmin jmsService = new JMSServiceAdmin();

  transportAdmin transport = new transportAdmin();

  securityAdmin security = new securityAdmin();

  corbaServiceAdmin corbaService = new corbaServiceAdmin();

  private static Log log =
      LogFactory.getLog(AxisServlet.class.getName());
  StringBuffer buffer = new StringBuffer();

  public AdminService() {

  }

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    try{
      process(request, response);
    }
    catch (Exception e) {
      try {
        request.setAttribute("info", e.getMessage());
        request.getRequestDispatcher(infoPage).forward(request,
            response);
      }
      catch (IOException e1) {

      }
      catch (ServletException e2) {
      }
      return;
    }

  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    try{
      process(request, response);
    }catch (Exception e) {
      try {
        request.setAttribute("info", e.getMessage());
        request.getRequestDispatcher(infoPage).forward(request,
            response);
      }
      catch (IOException e1) {

      }
      catch (ServletException e2) {
      }
      return;
    }

  }

  void process(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    buffer.setLength(0);
    //REVISIT: what happens if there is no engine?

    if (server == null) {
      server = getEngine();

      //process command
    }
    String cmd = request.getParameter("cmd");
    if (cmd == null) {

      processService(request, response);
    }
    else {
      //only in dev mode do these command work
      if (cmd.startsWith("UDDI")) {
        // UDDI_Forward.process(request,response,getServletContext());
      }
      if (cmd.startsWith("global")) {
        global.process(request, response, this, cmd);
      }

      if (cmd.startsWith("RBAC")) {
        security.process(request, response, this, cmd);
      }

      if (cmd.equals("start")) {
        server.start();
        cmd = "getStatus";
      }
      else if (cmd.equals("stop")) {
        server.stop();
        cmd = "getStatus";
      }
      else if (cmd.equals("addNewJavaService")) {

        addNewJavaService(request, response);
      }
      else if (cmd.equals("addNewCorbaService")) {
        addNewCorbaService(request, response);
      }

      //
      //add new CCM service
      //
      else if (cmd.equals("addNewCCMService")) {
        HttpSession session = request.getSession();
        session.removeValue("CCMServiceDesc");
        CCMServiceDeploy ccmService = new CCMServiceDeploy();
        session.putValue("CCMServiceDesc", ccmService);

        ccmService.addNewCCMService(request, response);
      }

      else if (cmd.equals("addNewCCMServiceBasicInfo")) {
        HttpSession session = request.getSession();
        CCMServiceDeploy ccmService = (CCMServiceDeploy) session.getValue(
            "CCMServiceDesc");

        ccmService.addNewCCMServiceBasicInfo(request, response);
        request.getRequestDispatcher("../admin/CCMService/addNewServiceMethodsInfo.jsp").forward(request,response);

      }

      else if (cmd.equals("addNewCCMServiceMethodsInfo")) {
        HttpSession session = request.getSession();
        CCMServiceDeploy ccmService = (CCMServiceDeploy) session.getValue(
            "CCMServiceDesc");

        ccmService.addNewCCMServiceMethodsInfo(request, response);
        deployService(request,response,ccmService.toString(),true);
      }

      //
      //show CCM service detail
      //
      else if (cmd.equals("ccmServiceDetail")) {
        getServiceDetail(request,response,"../admin/CCMService/serviceDetail.jsp");
      }

      //
      //modify CCM service detail
      //
      else if (cmd.equals("ccmShowServiceModify")) {
        getServiceDetail(request,response,"../admin/CCMService/modifyService.jsp");
      }

      else if (cmd.equals("ccmModifyServiceSuccess")) {
        CCMServiceDeploy ccmService = new CCMServiceDeploy();
        ccmService.ccmModifyServiceSuccess(request, response,this);
      }

      else if (cmd.equals("addServiceParameter")) {
        //  addServiceParameter(request,response);
      }

      //Step1: plus a new JMS Service
      //added by zk
      else if (cmd.equals("addNewJMSService")) {
        addNewJMSService(request, response);
      }

      else if (cmd.equals("login")) {
        //  login(request,response);
      }

      else if (cmd.equals("addNewHandler")) {
        addNewHandler(request, response);
      }

      else if (cmd.startsWith("java")) {
        javaService.process(request, response, this, cmd);
      }
      //added by zk

      else if (cmd.startsWith("jms")) {
        try{
          jmsService.process(request, response, this, cmd);
        }catch(Exception e){
          System.out.print(e.getMessage());
        }

      }

      else if (cmd.startsWith("transport")) {
        transport.process(request, response, this, cmd);
      }
      else if (cmd.startsWith("corba")) {
        corbaService.process(request, response, this, cmd);
      }

      else if (cmd.equals("deployService")) {
        deployService(request, response, true);
      }

      else if (cmd.equals("deployServiceStep")) {
        deployServiceStep(request, response);
      }
      else if (cmd.equals("undeployService")) {
        deployService(request, response, false);
      }

      else if (cmd.equals("getHandlerDetail")) {
        //   getHandlerDetail(request,response);
      }

      if (cmd.equals("getStatus")) {
        //in production we log a hostile probe. Remember: logs can be
        //used for DoS attacks themselves.
        if (server.isRunning()) {
          buffer.append(
              "Server is runningYou can <a href=\"AdminServlet?cmd=stop\"><b> Stop Server</b></a> ");
        }
        else {
          buffer.append(
              "Server is stopped. You can <a href=\"AdminServlet?cmd=start\"><b> Start Server.</b></a> ");
        }
        request.setAttribute("info", buffer);
        request.getRequestDispatcher(infoPage).forward(request,
            response);
        return;

      }

    }

  }

  void addNewCorbaService(HttpServletRequest request,
                          HttpServletResponse response) {
    HttpSession session = request.getSession();
    CORBAServiceDeploy desc = null;

    session.removeValue("serviceDesc");

    desc = new CORBAServiceDeploy();
    session.putValue("serviceDesc", desc);

    desc.writeStep(response, "1");

  }

  void deployServiceStep(HttpServletRequest request,
                         HttpServletResponse response) {

    HttpSession session = request.getSession();
    ServiceDeploy desc = (ServiceDeploy) session.getValue(
        "serviceDesc");
    if (desc == null) {
      return;
    }
    String step = request.getParameter("step");
    String nextStep = request.getParameter("nextStep");
    try {
      desc.setStep(request, response, step);
    }
    catch (Exception e) {
      try {
        request.setAttribute("info", e.getMessage());
        request.getRequestDispatcher(infoPage).forward(request,
            response);
      }
      catch (IOException e1) {

      }
      catch (ServletException e2) {
      }
      return;
    }

    if (nextStep.equals("confirm")) {
      deployService(request, response, true);
    }
    else {
      desc.writeStep(response, nextStep);

    }
  }

  void deployService(HttpServletRequest request, HttpServletResponse response,
                     boolean isDeployment) {
    HttpSession session = request.getSession();
    if (isDeployment) {
      ServiceDeploy desc = (ServiceDeploy) session.getValue("serviceDesc");
      if (desc == null) {
        return;
      }
      deployService(request, response, desc.toString(true), isDeployment);

    }
    else {
      String serviceName = request.getParameter("serviceName");
      deployService(request, response, serviceName, isDeployment);
    }

  }

  public void deployService(HttpServletRequest request, HttpServletResponse response,
                     String content, boolean isDeployment) {
    PrintWriter writer = null;
    try {
      writer = response.getWriter();
    }
    catch (IOException e) {
      return;
    }

    if (content != null) {
      if (!content.equals("")) {
        try {
          String body = null;
          if (isDeployment) {
            body = "<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +
                content + "</deployment>";
          }
          else {
            body = "<undeployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +
                "<service name=\"" + content + "\"/>" +
                "</undeployment>";
          }
          MessageContext msgContext = invokeAdmin(request, response,
                                                  body);
          if (msgContext != null) {
            Message respMsg = msgContext.getResponseMessage();
            if (respMsg != null) {

              request.setAttribute("info",
                                   respMsg.getSOAPPartAsString());
              request.getRequestDispatcher(infoPage).forward(
                  request, response);

            //  javaService.getServiceList(request,response,this);
            }
          }
        }
        catch (AxisFault e) {

        }
        catch (ServletException e2) {

        }
        catch (IOException e2) {

        }
        finally {
            writer.close();
        }


      }
    }

  }

  void getServiceDetail(HttpServletRequest request,
                        HttpServletResponse response, String location) {
    String serviceName = request.getParameter("name");
    Hashtable param = getServiceDetail(serviceName, request, response);

    java.util.Enumeration enum = param.keys();
    while (enum.hasMoreElements()) {
      String key = (String) enum.nextElement();
      request.setAttribute(key, param.get(key));
    }

    try {
      request.getRequestDispatcher(location).forward(request, response);
    }
    catch (java.io.IOException e) {

    }
    catch (javax.servlet.ServletException e) {

    }

  }

  Hashtable getServiceDetail(String serviceName, HttpServletRequest request,
                             HttpServletResponse response) {

    NodeList node = getDeloymentInfo(request, response, "service");
    Hashtable result = new Hashtable();

    if (node != null) {

      for (int i = 0; i < node.getLength(); i++) {

        Element e = (Element) node.item(i);

        if (!serviceName.equals(e.getAttribute("name"))) {
          continue;
        }
        result.put("name", e.getAttribute("name"));
        result.put("provider", e.getAttribute("provider"));
        result.put("style", e.getAttribute("style"));
        NodeList childNode = e.getChildNodes();

        for (int j = 0; j < childNode.getLength(); j++) {
          Node child = childNode.item(j);
          if (child.getNodeName().equals("parameter") &&
              child.hasAttributes()) {

            for (int k = 0; k < child.getAttributes().getLength();
                 k += 2) {
              result.put(child.getAttributes().item(k).
                         getNodeValue(),
                         child.
                         getAttributes().item(k + 1).
                         getNodeValue());

            }
          }

          //service.add(child.getAttribute("name"));
          //service.add(child.getAttribute("value"));
        }

      }

    }

    return result;

  }

  /**
   * get deploy infomation ,just service-config.wsdd file
   * @param request
   * @param response
   * @param infoName
   * @return
   */
  NodeList getDeloymentInfo(HttpServletRequest request,
                            HttpServletResponse response, String infoName) {
    PrintWriter writer = null;
    try {
      writer = response.getWriter();
    }
    catch (IOException e) {
      return null;
    }

    try {
      String body = "<list xmlns=\"http://xml.apache.org/axis/wsdd/\" xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\"/>";
      MessageContext msgContext = invokeAdmin(request, response, body);
      Message respMsg = msgContext.getResponseMessage();
      Document doc = null;
      javax.xml.soap.SOAPBody soapBody = null;

      doc = XMLUtils.newDocument(new InputSource(new StringReader(respMsg.
          getSOAPPartAsString())));
      java.util.StringTokenizer token = new java.util.StringTokenizer(
          infoName, "/");
      NodeList result = doc.getElementsByTagName(token.nextToken());

      while (token.hasMoreTokens()) {
        for (int i = 0; i < result.getLength(); i++) {
          Node n = result.item(i);
          NodeList list = n.getChildNodes();
          String index = token.nextToken();
          for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j).getNodeName().equals(index)) {
              result = list.item(j).getChildNodes();
              return result;
            }
          }

        }
        return null;

      }
      return result;

    }
    catch (AxisFault fault) {
      response.setContentType("text/html");
      response.setStatus(500);
      writer.println("<h2>" + Messages.getMessage("error00") + "</h2>");
      writer.println("<p>" + Messages.getMessage("somethingWrong00") +
                     "</p>");
      writer.println("<pre>Fault - " + fault.toString() + " </pre>");
      writer.println("<pre>" + fault.dumpToString() + " </pre>");

    }
    catch (IOException e2) {

    }
    writer.close();
    return null;

  }

  /**
   * invoke org.apache.axis.util.admin,return the MessageContext
   * @param request
   * @param response
   * @return
   * @throws AxisFault
   */
  public MessageContext invokeAdmin(HttpServletRequest request,
                             HttpServletResponse response, String bodyString) throws
      AxisFault {

    AxisEngine engine = getEngine();

    String msgtxt =
        "<SOAP-ENV:Envelope" +
        " xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
        "<SOAP-ENV:Body>" + bodyString + "</SOAP-ENV:Body>" +
        "</SOAP-ENV:Envelope>";

    ByteArrayInputStream istream =
        new ByteArrayInputStream(msgtxt.getBytes());
    MessageContext msgContext = createMessageContext(engine, request,
        response);
    Message msg = new Message(istream, false);
    msgContext.setRequestMessage(msg);
    engine.invoke(msgContext);

    return msgContext;
  }

  /**
   * only show a page for add a new service
   * function for realy add a new service is deplyService()
   * @param request
   * @param response
   */
  void addNewJavaService(HttpServletRequest request,
                         HttpServletResponse response) {
    HttpSession session = request.getSession();
    JavaServiceDeploy desc = null;

    session.removeValue("serviceDesc");

    desc = new JavaServiceDeploy();
    session.putValue("serviceDesc", desc);

    desc.writeStep(response, "1");

  }


  private MessageContext createMessageContext(AxisEngine engine,
                                              HttpServletRequest req,
                                              HttpServletResponse res) {
    MessageContext msgContext = new MessageContext(engine);

    //if(isDebug) {

    log.info("MessageContext:" + msgContext);
    log.info("HEADER_CONTENT_TYPE:" +
             req.getHeader(HTTPConstants.HEADER_CONTENT_TYPE));
    log.info("HEADER_CONTENT_LOCATION:" +
             req.getHeader(HTTPConstants.HEADER_CONTENT_LOCATION));
    log.info("Constants.MC_HOME_DIR:" + String.valueOf(getHomeDir()));
    log.info("Constants.MC_RELATIVE_PATH:" + req.getServletPath());

    log.info("HTTPConstants.MC_HTTP_SERVLETLOCATION:" +
             String.valueOf(getWebInfPath()));
    log.info("HTTPConstants.MC_HTTP_SERVLETPATHINFO:" +
             req.getPathInfo());
    log.info("HTTPConstants.HEADER_AUTHORIZATION:" +
             req.getHeader(HTTPConstants.HEADER_AUTHORIZATION));
    //log.info("Constants.MC_REMOTE_ADDR:"+req.getRemoteAddr());
    log.info("configPath:" + String.valueOf(getWebInfPath()));
    //}

    /* Set the Transport */
    /*********************/
    msgContext.setTransportName("http");
    String servletPath = "/service";
    String pathInfo = "/AdminService";
    /* Save some HTTP specific info in the bag in case someone needs it */
    /********************************************************************/
    msgContext.setProperty(Constants.MC_JWS_CLASSDIR, "");
    msgContext.setProperty(Constants.MC_HOME_DIR, getHomeDir());
    msgContext.setProperty(Constants.MC_RELATIVE_PATH,
                           servletPath);
    msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLET, this);
    msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETREQUEST, req);
    msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETRESPONSE, res);
    msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETLOCATION,
                           getWebInfPath());
    msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETPATHINFO,
                           pathInfo);
    msgContext.setProperty(HTTPConstants.HEADER_AUTHORIZATION,
                           req.getHeader(HTTPConstants.HEADER_AUTHORIZATION));

    //msgContext.setProperty(Constants.MC_REMOTE_ADDR, req.getRemoteAddr());

    // Set up a javax.xml.rpc.server.ServletEndpointContext
    ServletEndpointContextImpl sec = new ServletEndpointContextImpl();

    msgContext.setProperty(Constants.MC_SERVLET_ENDPOINT_CONTEXT, sec);
    /* Save the real path */
    /**********************/
    String realpath =
        getServletConfig().getServletContext()
        .getRealPath(servletPath);

    if (realpath != null) {
      msgContext.setProperty(Constants.MC_REALPATH, realpath);
    }

    msgContext.setProperty(Constants.MC_CONFIGPATH, getWebInfPath());

    return msgContext;
  }

  public void addNewHandler(HttpServletRequest request,
                            HttpServletResponse response) {
    String parent = (String) request.getParameter("parent");
    if (parent.equals("global")) {
      global.addNewHandler(request, response, this);
    }
    else if (parent.equals("transport")) {
      transport.addNewHandler(request, response, this);

    }
  }

  /**
   * Step2:
   * only show a page for add a new JMS service
   * function for realy add a new service is JMSServiceDeploy()
   * @param request
   * @param response
   * added: by zk
   */
  void addNewJMSService(HttpServletRequest request,
                        HttpServletResponse response) {
    HttpSession session = request.getSession();
    JMSServiceDeploy desc = null;

    session.removeValue("serviceDesc");

    desc = new JMSServiceDeploy();
    session.putValue("serviceDesc", desc);
    //desc.writeStep(response,"1");
    desc.showDeployPage(request, response);
  }

  public String getInfoPage() {
    return this.infoPage;
  }

  public void writerOutWithNodeList(HttpServletResponse response,
                                    NodeList node, String xsltURI) {
    StringBuffer buffer = new StringBuffer();
    for (int i = 0; i < node.getLength(); i++) {
      buffer.append(XMLUtils.ElementToString( (Element) node.item(i)));
    }
    writerOut(response, buffer.toString(), xsltURI);

  }

  public void writerOutWithNode(HttpServletResponse response, Node node,
                                String xsltURI) {

    writerOut(response, org.apache.axis.utils.DOM2Writer.nodeToString(node, true),
              xsltURI);
  }

  public void writerOut(HttpServletResponse response, String content,
                        String xsltURI) {
    PrintWriter writer = null;
    try {
      writer = response.getWriter();
    }
    catch (IOException e) {
      return;
    }
    response.setContentType("text/xml");

    writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                   "\"?>");
    writer.println("<deployment>");
    writer.println(content);
    writer.println("</deployment>");
    writer.close();

  }
  /**
   * if request is for get service's WSDL,then we check whether it is for CORBA service's
   * WSDL,if so we get WSDL file from /WSDL/xxx.wsdl ,if not we dispatch it to axis's AxisServlet
   * @param request
   * @param response
   */
  public void processService(HttpServletRequest request,
                             HttpServletResponse response) {

    AxisServlet axis = new AxisServlet();
    String servletPath = request.getPathInfo();
    String queryString = request.getQueryString();
    if (queryString != null) {
      if (queryString.equalsIgnoreCase("wsdl")) {

        String serviceName = servletPath.substring(1);
        Hashtable param = getServiceDetail(serviceName, request, response);
        String provider = (String) param.get("provider");
        String handler = (String) param.get("handlerClass");
        if (provider.equalsIgnoreCase("handler")) {
          if (handler.equals(
              "net.starmiddleware.starws2.providers.corba.DynProvider") ||
              (handler.equals("net.starmiddleware.starws2.providers.ccm.CCMProvider"))) {
            String buffer = corbaService.getServiceWSDL(serviceName);
            if (buffer.startsWith("<?xml")) {
              response.setContentType("text/xml");
              try {
                response.getWriter().write(buffer.toString());
              }
              catch (IOException e) {

              }
            }
            else {
              try {
                request.setAttribute("info", buffer);
                request.getRequestDispatcher("admin/info.jsp").forward(request,
                    response);
              }
              catch (javax.servlet.ServletException e1) {

              }
              catch (java.io.IOException e2) {

              }
            }
            return;

          }
        }
      }

      try {
        request.getRequestDispatcher("AxisServlet/" + servletPath + "?" +
                                     request.getQueryString()).forward(request,
            response);

      }
      catch (java.io.IOException e1) {

      }
      catch (javax.servlet.ServletException e2) {

      }

    }else{
      try {
        request.getRequestDispatcher("AxisServlet/"+servletPath).forward(request,
            response);

      }
      catch (java.io.IOException e1) {

      }
      catch (javax.servlet.ServletException e2) {

      }


  }

  }
}
