package net.starmiddleware.starws2.transport.http.admin;


import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import java.io.IOException;
import org.apache.axis.AxisFault;
import net.starmiddleware.starws2.transport.http.admin.deploy.ServiceDeploy;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author zk
 * @version 1.0
 */

public class JMSServiceAdmin {
  public JMSServiceAdmin() {
  }

  public void process(HttpServletRequest request, HttpServletResponse response,
                      AdminService admin, String command)throws Exception {

    if(command.equals("jmsServiceList")){
      getServiceList(request, response, admin);
    }
    else if(command.equals("jmsServiceDetail")){
       getServiceDetail(request, response, admin);
    }
    else if(command.equals("jmsShowServiceModify")){
       showModifyJMSService(request, response, admin);
    }
    else if(command.equals("jmsServiceModify")){
      modifyJMSService(request,response,admin);
    }
    else if(command.equals("jmsConfirm")){
      jmsConfirm(request,response,admin);
    }


  }

  public String modifyService(HttpServletRequest request,
                              HttpServletResponse response) {
    return "ok";

  }

  public void jmsConfirm(HttpServletRequest request,
                              HttpServletResponse response,AdminService admin)throws Exception{
         HttpSession session = request.getSession();
         ServiceDeploy desc = (ServiceDeploy) session.getValue("serviceDesc");

         desc.setStep(request,response,"1");
         admin.deployService(request,response,true);
         //admin.deployService();

  }

  void getServiceList(HttpServletRequest request, HttpServletResponse response,
                      AdminService admin) {

    NodeList node = admin.getDeloymentInfo(request, response, "service");

    if (node != null) {
      Vector service = new Vector();
      for (int i = 0; i < node.getLength(); i++) {
        Element e = (Element) node.item(i);
        service.add(e.getAttribute("name"));
        String provider = e.getAttribute("provider");
        service.add(provider);
        if (provider.startsWith("java")){
          service.add("java");
        }
        else if(provider.startsWith("java")){
          service.add("corba");
        }
        //added by zk
        else if(provider.startsWith("jms")){
          service.add("jms");
        }

      }
      request.setAttribute("service", service);
    }

    try {
      request.getRequestDispatcher("../admin/service.jsp").forward(request,
          response);
    }
    catch (java.io.IOException e) {

    }
    catch (javax.servlet.ServletException e) {

    }
    return;
  }

  void getServiceDetail(HttpServletRequest request,
                        HttpServletResponse response, AdminService admin) {
    admin.getServiceDetail(request, response,
                           "../admin/JMSService/serviceDetail.jsp");
  }

  void showModifyJMSService(HttpServletRequest request,
                             HttpServletResponse response, AdminService admin) {
    admin.getServiceDetail(request, response,
                           "../admin/JMSService/modifyService.jsp");
  }

  public void modifyJMSService(HttpServletRequest request,
                                HttpServletResponse response,
                                AdminService admin) {
    StringBuffer buffer = new StringBuffer();
    String serviceName = request.getParameter("name");
    String provider = request.getParameter("provider");
    //String style = request.getParameter("style");
    buffer.append("<service name=\"" + serviceName + "\" provider=\"" +
                  provider + "\">");
    Enumeration param = request.getParameterNames();
    while (param.hasMoreElements()) {
      String name = (String) param.nextElement();
      if ( (!name.equals("name")) && (!name.equals("provider")) &&
          (!name.equals("cmd")) && (!name.equals("style")) &&
          (!name.equals("location"))) {
        buffer.append("<parameter name=\"" + name + "\" value=\"" +
                      request.getParameter(name) + "\"/>");
      }
    }
    buffer.append("<parameter name=\"handlerClass\" value=\"net.starmiddleware.starws2.providers.jms.JMSProvider\"/>");
    buffer.append(" </service>");

    try {
      String body = null;
      body = "<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +
          buffer.toString() + "</deployment>";

      Object msgContext = admin.invokeAdmin(request, response, body);
      if (msgContext != null) {

        request.setAttribute("info", "Service " + serviceName + "has been modified successfully.");
        request.getRequestDispatcher(admin.getInfoPage()).forward(request,
            response);

      }
    }
    catch (AxisFault e) {

    }
    catch (ServletException e2) {

    }
    catch (IOException e2) {

    }
  }





}
