package net.starmiddleware.starws2.transport.http.admin;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;
import javax.servlet.ServletException;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import org.apache.axis.AxisFault;
import net.starmiddleware.starws2.wsdl.IDL2WSDL;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.File;
import org.apache.axis.i18n.Messages;
import com.jspsmart.upload.*;

public class corbaServiceAdmin {
  public corbaServiceAdmin() {
  }

  public void process(HttpServletRequest request,HttpServletResponse response,AdminService admin,String command){

  if(command.equals("corbaServiceDetail")){
      getServiceDetail(request, response, admin);
   }
  else if(command.equals("corbaShowServiceModify")) {
     showModifyCorbaService(request,response,admin);
  }
  else if(command.equals("corbaServiceModify")){
      modifyCorbaService(request,response,admin);
  }
  else if(command.equals("corbaCompileWSDL")){
      compileWSDL(request,response,admin);
  }



 }
 /**
  * get service Detail information,and display it in the interface
  * @param request
  * @param response
  * @param admin
  */
 void getServiceDetail(HttpServletRequest request,HttpServletResponse response,AdminService admin){
    admin.getServiceDetail(request,response,"../admin/CORBAService/serviceDetail.jsp");
  }
  /**
   * get sevice Detail information, and display it in a modify Interface
   * @param request
   * @param response
   * @param admin
   */

  void showModifyCorbaService(HttpServletRequest request,HttpServletResponse response,AdminService admin){
       admin.getServiceDetail(request,response,"../admin/CORBAService/modifyService.jsp");

     }
     /**
      * get service modify information,and change service configure
      * realy we first re-depoly service ,and have not consider if those who
      * is using service,it maybe make some error reponse for those users.
      * @param request
      * @param response
      * @param admin
      */
     public void modifyCorbaService(HttpServletRequest request, HttpServletResponse response,AdminService admin){
         StringBuffer buffer=new StringBuffer();
         String serviceName=request.getParameter("name");
         String provider=request.getParameter("provider");
         String style=request.getParameter("style");
         buffer.append("<service name=\""+serviceName+"\" provider=\""+provider+"\" style=\""+style+"\">");
         Enumeration param=request.getParameterNames();
         while(param.hasMoreElements()){
           String name=(String)param.nextElement();
           if((!name.equals("name"))&&(!name.equals("provider"))&&(!name.equals("cmd"))&&(!name.equals("style"))&&(!name.equals("location"))){
              buffer.append("<parameter name=\""+name+"\" value=\""+request.getParameter(name)+"\"/>");
           }
         }
         buffer.append("<parameter name=\"handlerClass\" value=\"net.starmiddleware.starws2.providers.corba.DynProvider\"/>");
         buffer.append(" </service>");

         try {
             String body=null;
             body = "<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +buffer.toString() + "</deployment>";

             Object msgContext =admin.invokeAdmin(request, response, body);
             if (msgContext != null) {

                 request.setAttribute("info", "Service " + serviceName + " has been modified successfully.");
                 request.getRequestDispatcher(admin.getInfoPage()).forward(request, response);

             }
           }
           catch (AxisFault e) {

           }
           catch (ServletException e2) {

           }
           catch (IOException e2) {

           }


        }
        /**
         * get CORBA service's WSDL,user must compile IDL to WSDL in user interface,otherwise
         * we can not get WSDL file from disk;
         * @param serviceName
         * @return
         */
  public String getServiceWSDL(String serviceName) {
    String  result=null;
    String path=System.getProperty("starws.home");
    serviceName=serviceName.replace(':','_');
    File file=new  File(path + "/wsdl/" + serviceName + ".wsdl");
    long length=file.length();
    byte[] buffer=new byte[(int)length];
    try{
      BufferedInputStream bis = new BufferedInputStream(new FileInputStream(file));
      bis.read(buffer);
       result=new String(buffer);


    }catch(java.io.IOException e){
        result=Messages.getMessage("IDLCompileNotComplete");
    }
    return result;

  }
  /**
   * compile CORBA service's IDL file to WSDL
   * @param request
   * @param response
   * @param admin
   */
  void compileWSDL(HttpServletRequest request,HttpServletResponse response,AdminService admin){

    String path=System.getProperty("starws.home");
    // Variables
        int count=0;
        com.jspsmart.upload.SmartUpload mySmartUpload=new com.jspsmart.upload.SmartUpload();



        try {
          // Initialization
          mySmartUpload.initialize(admin.getServletConfig(), request, response);

          mySmartUpload.setTotalMaxFileSize(100000);

               // Upload
                  mySmartUpload.upload();

                // Save the files with their original names in the virtual path "/upload"
                // if it doesn't exist try to save in the physical path "/upload"
                count = mySmartUpload.save("/admin/idl");

                // Save the files with their original names in the virtual path "/upload"
                // count = mySmartUpload.save("/upload", mySmartUpload.SAVE_VIRTUAL);

                // Display the number of files uploaded
                //request.getRequestDispatcher("../../servlet/AdminServlet?cmd=corbaCompileWSDL").forward(request, response);
        } catch (Exception e) {
                System.out.println(e.toString());
        }

    String filename=mySmartUpload.filename();
    String result="";
    if((filename==null)||(filename.equals(""))){

      result=Messages.getMessage("IDLCompileNoFile");
    }else{
      String binding =mySmartUpload.getRequest().getParameter("binding");
      String corbaName = mySmartUpload.getRequest().getParameter("corbaName");

      IDL2WSDL idl2wsdl = new IDL2WSDL();

      String[] args = new String[7];
      String serverName = request.getServerName();
      int serverPort = request.getServerPort();
      String servletPath = request.getContextPath();

      args[0] = "-l";
      args[1] = "http://" + serverName + ":" + serverPort  + servletPath +
          "/services/" + corbaName;

      // char old='
      corbaName = corbaName.replace(':', '_');

      args[2] = "-o";
      args[3] = path + "/wsdl/" + corbaName + ".wsdl";
      //args[1]="-o aaa.wsdl";
      args[4] = "-u";
      if (binding.equals("encoding"))
        args[5] = "encoded";
      else
        args[5] = "literal";

      args[6] = path+"/webapps"+servletPath+"/admin/idl/"+ filename;
      result = corbaName + Messages.getMessage("IDLCompileSuccess");

      try {
        idl2wsdl.run(args);
      }
      catch (Exception e) {
        result = e.toString();
      }
    }
      try {
            request.setAttribute("info", result);
            request.getRequestDispatcher(admin.getInfoPage()).forward(request, response);
           }
           catch (AxisFault e) {

           }
           catch (ServletException e2) {

           }
           catch (IOException e2) {

           }

  }

}
