package net.starmiddleware.starws2.transport.http.admin.deploy;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.axis.description.ServiceDesc;
import java.util.Enumeration;
import java.util.*;
import java.io.IOException;
import java.io.PrintWriter;
import org.apache.axis.AxisFault;

public class JMSServiceDeploy implements ServiceDeploy{

  public String serviceName = null;
  public String provider = null;
  public String handlerClass = null;
  public String allowedMethods = null;
  public String jmsDestinationName = null;
  public String jndiproperties = null;
  public String className = null;
  public String jmsMessageType = null;

  final static String processElementsMessageService = "processElementsMessageService";
  final static String processDocumentMessageSerivce = "processDocumentMessageSerivce";
  final static String processSoapBodyElementMessageService = "processSoapBodyElementMessageService";
  final static String processSoapEnvelopeMessageService = "processSoapEnvelopeMessageService";
  final static String processElements = "processElements";
  final static String processDocument = "processDocument";
  final static String processSoapBodyElement = "processSoapBodyElement";
  final static String processsoapEnvelope = "processsoapEnvelope";

  ServiceDesc desc=new ServiceDesc();
  Hashtable param=new Hashtable();

  public JMSServiceDeploy() {
  }

  /**
   * following are methods needed to implements
   * added by zk
   */

  public void setStep(HttpServletRequest request, HttpServletResponse response,
                      String step) throws Exception {

    setServiceName( (String) request.getParameter("name"));
    setHandlerClass( (String) request.getParameter("handlerClass"));
    setallowedMethods( (String) request.getParameter("allowedMethods"));
    setProviderType((String) request.getParameter("provider"));
    try {
      setJMSDestinationName( (String) request.getParameter("JMSDestination"));
    }
    catch (Exception e) {
      throw new Exception("<strong><p>can not load service's class--" +
                          request.getParameter("JMSDestinationName") +
                          ":</p></strong>" + e.getMessage());
    }

    try {
      setjndiproperties((String) request.getParameter("jndiproperties"));
    }
    catch (Exception e) {
      throw new Exception("<strong><p>can not load service's class--" +
                          request.getParameter("jndiproperties") +
                          ":</p></strong>" + e.getMessage());
    }

    setClassName( (String) request.getParameter("className"));
    setJMSMessageType( (String) request.getParameter("JMSMessageType"));

  }


  public void writeStep(HttpServletResponse response, String step){

    String xsltURI = null;
    if(step.equals("1")) xsltURI="../admin/JMSService/addNewService.xsl";
    //String xsltURI = "../admin/JMSService/addNewService.xsl";

    PrintWriter writer = null;
    try {
      writer = response.getWriter();
    }
    catch (IOException e) {
      return;
    }
    response.setContentType("text/xml");

    writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                   "\"?>");
    //writer.println("<link href="+"\"../admin/css/public.css\""+" rel="+"\"stylesheet\""+" type="+"\"text/css>\"");
    writer.println("<deployment xmlns="+"\"http://xml.apache.org/axis/wsdd/\"" +" xmlns:java="+"\"http://xml.apache.org/axis/wsdd/providers/java\">");
    //writer.println("<service ><parameter/><parameter/><parameter/><parameter/></service>");
    writer.println(this.toString(false));

    writer.println("<action name=\"deployServiceStep\"></action>");
    writer.println("</deployment>");
    writer.close();

  }

  public void showDeployPage(HttpServletRequest request,HttpServletResponse response){

    try {
      request.getRequestDispatcher("../admin/JMSService/addNewJMSService.jsp").forward(request, response);
    }
    catch (java.io.IOException e) {

    }
    catch (javax.servlet.ServletException e) {

    }


  }

  public String toString(boolean isDeploy){
    //setStep();
    StringBuffer result = new StringBuffer();
    result.append("<service ");

    if (getServiceName() != null) {
      result.append("name=\"" + this.getServiceName() + "\" ");
      result.append("provider=\"" + this.getProviderType() + "\"");
    }
    result.append(">");

    if(getHandlerClass() != null){
      result.append("<parameter name=\"handlerClass\" value=\"" +
                    getHandlerClass() +
                    "\"/>");
    }

    if(getJMSMessageType() != null){
      result.append("<parameter name=\"JMSMessageType\" value=\"" +
                    getJMSMessageType() +
                    "\"/>");
    }

    if (getallowedMethods() != null) {

      if (getServiceName().equals(processElementsMessageService)) {
        allowedMethods = processElements;
      }
      else if (getServiceName().equals(processDocumentMessageSerivce)) {
        allowedMethods = processDocument;
      }
      else if (getServiceName().equals(processSoapBodyElementMessageService)) {
        allowedMethods = processSoapBodyElement;
      }
      else if (getServiceName().equals(processSoapEnvelopeMessageService)) {
        allowedMethods = processsoapEnvelope;
      }
      result.append("<parameter name=\"allowedMethods\" value=\"" +
                    getallowedMethods() +
                    "\"/>");
    }

    if(getJMSDestinationName() != null){
      result.append("<parameter name=\"JMSDestinationName\" value=\"" + getJMSDestinationName() +
                  "\"/>");
    }

    if(getjndiproperties() !=null){

      result.append("<parameter name=\"jndiproperties\" value=\"" +
                    getjndiproperties() +
                    "\"/>");
    }

    if(getClassName() != null){
      result.append("<parameter name=\"className\" value=\"" +
              //desc.getImplClass().getName()
              getClassName() + "\"/>");
    }
    if (param.isEmpty()) {
      if (!isDeploy) {
        result.append("<parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/>");
      }
    }
    else {
      Enumeration enum = param.keys();
      while (enum.hasMoreElements()) {
        String key = (String) enum.nextElement();
        result.append("<parameter name=\"" + key + "\" value=\"" +
                      param.get(key) + "\"> </parameter>");
      }

    }
    result.append("</service>");
    return result.toString();

  }

  public String getServiceName(){
    return serviceName;
  }
  public void setServiceName(String name){
    serviceName = name;
  }
  public String getProviderType() {
    return provider;
  }

  public void setProviderType(String name) {
    provider = name;
  }

  public String getHandlerClass() {
    return handlerClass;
  }

  public void setHandlerClass(String name) {
    handlerClass = name;
  }

  public String getallowedMethods() {
    return allowedMethods;
  }

  public void setallowedMethods(String name) {
    allowedMethods = name;
  }

  public String getJMSDestinationName() {
    return jmsDestinationName;
  }

  public void setJMSDestinationName(String name) {
    jmsDestinationName = name;
  }

  public String getjndiproperties() {
    return jndiproperties;
  }

  public void setjndiproperties(String name) {
    jndiproperties = name;
  }

  public String getClassName() {
    return className;
  }

  public void setClassName(String name) {
    className = name;
  }

  public String getJMSMessageType() {
    return jmsMessageType;
  }

  public void setJMSMessageType(String name) {
    jmsMessageType = name;
  }

}
