package org.apache.axis.utils.tools;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.io.*;
import java.net.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.basic.BasicButtonListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.*;
import java.util.Vector;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;

public class Listener extends JPanel {
        public  Socket      inputSocket     = null ;
        public  Socket      outputSocket    = null ;
        public  JTextField  portField       = null ;
        public  JTextField  hostField       = null ;
        public  JTextField  tPortField      = null ;
        public  JCheckBox   isProxyBox      = null ;
        public  JButton     stopButton      = null ;
        public  JButton     removeButton    = null ;
        public  JButton     removeAllButton = null ;
        public  JCheckBox   xmlFormatBox    = null ;
        public  JButton     saveButton      = null ;
        public  JButton     resendButton    = null ;
        public  JButton     switchButton    = null ;
        public  JButton     closeButton     = null ;
        public  JTable      connectionTable = null ;
        public  DefaultTableModel  tableModel      = null ;
        public  JSplitPane  outPane         = null ;
        public  ServerSocket sSocket        = null ;
        public  SocketWaiter sw = null ;
        public  JPanel      leftPanel       = null ;
        public  JPanel      rightPanel      = null ;
        public  JTabbedPane notebook        = null ;
        public  String      HTTPProxyHost   = null ;
        public  int         HTTPProxyPort   = 80 ;
        JPanel bottomPane=new JPanel();

        final public Vector connections = new Vector();
        int listenPort;
        String host;
        int targetPort;
        boolean isProxy;

        String name;
        JPanel jPanel1 = new JPanel();
        JScrollPane countScrollPane = new JScrollPane();

        OverlayLayout2 overlayLayout21 = new OverlayLayout2();
  JScrollPane leftScrollPane = new JScrollPane();
  JScrollPane rightScrollPane = new JScrollPane();
  JPanel countInfo = new JPanel();
        //OverlayLayout overlayLayout21 = new OverlayLayout(null);




        public Listener(JTabbedPane _notebook, String name,
                        int listenPort, String host, int targetPort,
                        boolean isProxy) {
          notebook = _notebook;
          if (name == null)
            name = tcpmon.getMessage("port01", "Port") + " " + listenPort;
          this.name=name;
          this.host=host;
          this.targetPort=targetPort;
          this.listenPort=listenPort;
          this.isProxy=isProxy;
          try{
             jbInit();
            }
            catch (Exception e) {
              e.printStackTrace();
            }
            notebook.addTab( name, this );
            start();
        }
        private void jbInit(){

            this.setLayout( new BorderLayout() );

            // 1st component is just a row of labels and 1-line entry fields
            /////////////////////////////////////////////////////////////////////
            JPanel top = new JPanel();



           BoxLayout boxLayout=new BoxLayout(top, BoxLayout.X_AXIS);
           //top.setLayout( ) );
           // top.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
            final String start = tcpmon.getMessage("start00", "Start");
            stopButton = new JButton(start );




    top.add( stopButton,null );

            top.add( Box.createRigidArea(new Dimension(5, 0)) );
            JLabel lable= new JLabel( "  " + tcpmon.getMessage("listenPort01", "Listen Port:") + " ", SwingConstants.RIGHT ) ;
            top.add(lable );
            portField = new JTextField( "" + listenPort, 4 ) ;
            top.add( portField );
            JLabel lable2=new JLabel( "  " + tcpmon.getMessage("host00", "Host:"), SwingConstants.RIGHT );
            top.add( lable2 );
            hostField = new JTextField( host, 30 );
            top.add( hostField );
            JLabel lable3=new JLabel( "  " + tcpmon.getMessage("port02", "Port:") + " ", SwingConstants.RIGHT ) ;
            top.add(lable3);
            tPortField = new JTextField( "" + targetPort, 4 );
            top.add( tPortField );
            top.add( Box.createRigidArea(new Dimension(5, 0)) );
            isProxyBox = new JCheckBox(tcpmon.getMessage("proxy00", "Proxy"));
            top.add(isProxyBox);



            isProxyBox.addChangeListener( new BasicButtonListener(isProxyBox) {
                    public void stateChanged(ChangeEvent event) {
                        JCheckBox box = (JCheckBox) event.getSource();
                        boolean state = box.isSelected();

                        tPortField.setEnabled( !state );
                        hostField.setEnabled( !state );
                    }
                }
            );

            isProxyBox.setSelected(isProxy);

            portField.setEditable(false);
            portField.setMaximumSize(new Dimension(50, Short.MAX_VALUE) );
            hostField.setEditable(false);
            hostField.setMaximumSize(new Dimension(85, Short.MAX_VALUE) );
            tPortField.setEditable(false);
            tPortField.setMaximumSize(new Dimension(50, Short.MAX_VALUE) );

            stopButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if ( tcpmon.getMessage("stop00", "Stop").equals(event.getActionCommand()) ) stop();
                        if ( start.equals(event.getActionCommand()) ) start();
                    }
                }
            );

            this.add( top, BorderLayout.NORTH );

            // 2nd component is a split pane with a table on the top
            // and the request/response text areas on the bottom
            /////////////////////////////////////////////////////////////////////

            tableModel = new DefaultTableModel(new String[] {
                    tcpmon.getMessage("state00", "State"),
                    tcpmon.getMessage("time00", "Time"),
                    tcpmon.getMessage("requestHost00", "Request Host"),
                    tcpmon.getMessage("targetHost", "Target Host"),
                    tcpmon.getMessage("request00", "Request...")
                } , 0 );

            connectionTable = new JTable(1, 2);
            connectionTable.setModel( tableModel );
            connectionTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
            // Reduce the STATE column and increase the REQ column
            TableColumn col ;

            col = connectionTable.getColumnModel().getColumn(tcpmon.STATE_COLUMN);
            col.setMaxWidth( col.getPreferredWidth() / 2 );
            col = connectionTable.getColumnModel().getColumn(tcpmon.REQ_COLUMN);
            col.setPreferredWidth( col.getPreferredWidth() * 2 );


            ListSelectionModel sel = connectionTable.getSelectionModel();

            sel.addListSelectionListener( new ListSelectionListener() {
                    public void valueChanged(ListSelectionEvent event) {
                        if (event.getValueIsAdjusting()) return ;
                        ListSelectionModel m = (ListSelectionModel) event.getSource();
                        int divLoc = outPane.getDividerLocation();

                        if (m.isSelectionEmpty()) {
                            setLeft( new JLabel(" " + tcpmon.getMessage("wait00", "Waiting for Connection...") ) );
                            setRight( new JLabel("") );
                            setBottom(new JLabel("no infomation"));
                            removeButton.setEnabled(false);
                            removeAllButton.setEnabled(false);
                            saveButton.setEnabled(false);
                            resendButton.setEnabled(false);
                        }
                        else {
                            int row = m.getLeadSelectionIndex();

                            if ( row == 0 ) {
                                if ( connections.size() == 0 ) {
                                    setLeft(new JLabel(" " + tcpmon.getMessage("wait00", "Waiting for connection...")));
                                    setRight(new JLabel(""));
                                    removeButton.setEnabled(false);
                                    removeAllButton.setEnabled(false);
                                    saveButton.setEnabled(false);
                                    resendButton.setEnabled(false);
                                }
                                else {
                                    Connection conn = (Connection) connections.lastElement();

                                    setLeft( conn.inputText );
                                    setRight( conn.outputText );
                                    setBottom(conn.info);

                                    removeButton.setEnabled(false);
                                    removeAllButton.setEnabled(true);
                                    saveButton.setEnabled(true);
                                    resendButton.setEnabled(true);
                                }
                            }
                            else {
                                Connection conn = (Connection) connections.get(row - 1);

                                setLeft( conn.inputText );
                                setRight( conn.outputText );
                                setBottom(conn.info);

                                removeButton.setEnabled(true);
                                removeAllButton.setEnabled(true);
                                saveButton.setEnabled(true);
                                resendButton.setEnabled(true);
                            }
                        }
                        outPane.setDividerLocation(divLoc);
                    }
                }
            );
            tableModel.addRow( new Object[] {
                    "---", tcpmon.getMessage("mostRecent00", "Most Recent"), "---", "---", "---"
                }
            );

            JPanel  tablePane = new JPanel();

            tablePane.setLayout( new BorderLayout() );


            JScrollPane tableScrollPane = new JScrollPane( connectionTable );

            tablePane.add( tableScrollPane, BorderLayout.CENTER );
            JPanel buttons = new JPanel();

            //buttons.setLayout( boxLayout );
            //buttons.setBorder( BorderFactory.createEmptyBorder(5, 5, 5, 5) );
            final String removeSelected = tcpmon.getMessage("removeSelected00", "Remove Selected");
            removeButton = new JButton(removeSelected);
            buttons.add( removeButton );
            buttons.add( Box.createRigidArea(new Dimension(5, 0)) );
            final String removeAll = tcpmon.getMessage("removeAll00", "Remove All");
            removeAllButton = new JButton(removeAll);
            buttons.add( removeAllButton );
            tablePane.add( buttons, BorderLayout.SOUTH );


             removeButton.setEnabled( false );
            removeButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if ( removeSelected.equals(event.getActionCommand()) ) remove();
                    }
                }
            );

            removeAllButton.setEnabled( false );
            removeAllButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if ( removeAll.equals(event.getActionCommand()) ) removeAll();
                    }
                }
            );


             // Add Response Section
            /////////////////////////////////////////////////////////////////////
           JPanel     pane2     = new JPanel();

           pane2.setLayout( new BorderLayout() );
           pane2.setBorder(BorderFactory.createEtchedBorder());
           JScrollPane cLeftPane=new JScrollPane();
           JScrollPane cRightPane=new JScrollPane();
           leftPanel = new JPanel();
           leftPanel.setAlignmentX(Component.LEFT_ALIGNMENT);
           //leftPanel.setLayout( new BoxLayout(leftPanel, BoxLayout.Y_AXIS) );
           JLabel lable5 = new JLabel("  " + tcpmon.getMessage("request01", "Request"));
           leftPanel.add(lable5);
           JLabel lable6 = new JLabel(" " +
                                      tcpmon.getMessage("wait01", "Waiting for connection"));
           leftPanel.add(lable6);

            leftScrollPane.getViewport().add(leftPanel);
            rightPanel = new JPanel();
            //rightPanel.setLayout( new BoxLayout(rightPanel, BoxLayout.Y_AXIS) );
            JLabel lable7=new JLabel("  " + tcpmon.getMessage("response00", "Response"));
            rightPanel.add( lable7 );
            rightScrollPane.getViewport().add(rightPanel);
            rightPanel.add( new JLabel("") );


            outPane = new JSplitPane();

            outPane.add(leftScrollPane,JSplitPane.LEFT);


            outPane.add(rightScrollPane,JSplitPane.RIGHT );

            JSplitPane mainPane=new JSplitPane();
            mainPane.add(outPane,JSplitPane.TOP);

            mainPane.add(bottomPane,JSplitPane.BOTTOM);
            bottomPane.add(countScrollPane, null);
    countScrollPane.getViewport().add(countInfo, null);
            bottomPane.setLayout(overlayLayout21);


            mainPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
            mainPane.setDividerLocation(200);

            outPane.setDividerSize(4);
            pane2.add( mainPane, BorderLayout.CENTER );

            JPanel bottomButtons = new JPanel();

            //bottomButtons.setLayout( new BoxLayout(bottomButtons, BoxLayout.X_AXIS));
            bottomButtons.setBorder(BorderFactory.createEtchedBorder());
            bottomButtons.add( xmlFormatBox = new JCheckBox( tcpmon.getMessage("xmlFormat00", "XML Format") ) );
            bottomButtons.add( Box.createRigidArea(new Dimension(5, 0)) );
            final String save = tcpmon.getMessage("save00", "Save");
            saveButton = new JButton(save);
            bottomButtons.add(saveButton);
            bottomButtons.add(Box.createRigidArea(new Dimension(5, 0)));
            final String resend = tcpmon.getMessage("resend00", "Resend");
            resendButton = new JButton(resend);
            bottomButtons.add(resendButton);
            bottomButtons.add(Box.createRigidArea(new Dimension(5, 0)));
            final String switchStr = tcpmon.getMessage("switch00", "Switch Layout");
            switchButton = new JButton(switchStr);
            bottomButtons.add(switchButton);
            bottomButtons.add(Box.createHorizontalGlue());
            final String close = tcpmon.getMessage("close00", "Close");
            closeButton = new JButton(close);
            bottomButtons.add(closeButton);
            pane2.add( bottomButtons, BorderLayout.SOUTH );

            saveButton.setEnabled( false );
            saveButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if ( save.equals(event.getActionCommand()) ) save();
                    }
                }
            );

            resendButton.setEnabled( false );
            resendButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if ( resend.equals(event.getActionCommand()) ) resend();
                    }
                }
            );

            switchButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if (switchStr.equals(event.getActionCommand()) ) {
                            int v = outPane.getOrientation();

                            if ( v == 0 )  // top/bottom
                                outPane.setOrientation(1);
                            else  // left/right
                                outPane.setOrientation(0);
                            outPane.setDividerLocation(0.5);
                        }
                    }
                }
            );

            closeButton.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        if (close.equals(event.getActionCommand()) )
                            close();
                    }
                }
            );


         JSplitPane  pane1 = new JSplitPane(0 );
         pane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
         this.add(pane1, BorderLayout.CENTER);
         pane1.add(tablePane, JSplitPane.TOP);
         pane1.add(pane2,JSplitPane.BOTTOM);
          pane1.setDividerSize(4);

           pane1.setDividerLocation(150 );


            //
            ////////////////////////////////////////////////////////////////////
            sel.setSelectionInterval(0, 0);
            outPane.setDividerLocation(350 );




        }

        public void setLeft(Component left) {
            leftPanel.removeAll();
            leftPanel.add(left);
        }
        public void setBottom(Component comp) {
            countInfo.removeAll();
            countInfo.add(comp);
            countInfo.repaint();
        }

        public void setRight(Component right) {
            rightPanel.removeAll();
            rightPanel.add(right);
        }

        public void start() {
            int  port = Integer.parseInt( portField.getText() );

            portField.setText( "" + port );
            int i = notebook.indexOfComponent( this );

            notebook.setTitleAt( i, tcpmon.getMessage("port01", "Port") + " " + port );

            int  tmp = Integer.parseInt( tPortField.getText() );

            tPortField.setText( "" + tmp );

            sw = new SocketWaiter( this, port );
            stopButton.setText( tcpmon.getMessage("stop00", "Stop") );

            portField.setEditable(false);
            hostField.setEditable(false);
            tPortField.setEditable(false);
            isProxyBox.setEnabled(false);
        }

        public void close() {
            stop();
            notebook.remove( this );
        }

        public void stop() {
            try {
                for ( int i = 0 ; i < connections.size() ; i++ ) {
                    Connection conn = (Connection) connections.get( i );

                    conn.halt();
                }
                sw.halt();
                stopButton.setText( tcpmon.getMessage("start00", "Start") );
                portField.setEditable(true);
                hostField.setEditable(true);
                tPortField.setEditable(true);
                isProxyBox.setEnabled(true);
            }
            catch ( Exception e ) {
                e.printStackTrace();
            }
        }

        public void remove() {
            ListSelectionModel lsm = connectionTable.getSelectionModel();
            int bot = lsm.getMinSelectionIndex();
            int top = lsm.getMaxSelectionIndex();

            for ( int i = top ; i >= bot ; i-- ) {
                ((Connection) connections.get(i - 1)).remove();
            }
            if ( bot > connections.size() ) bot = connections.size();
            lsm.setSelectionInterval(bot, bot);
        }

        public void removeAll() {
            ListSelectionModel lsm = connectionTable.getSelectionModel();
            lsm.clearSelection();
            while ( connections.size() > 0 )
                ((Connection) connections.get(0)).remove();

            lsm.setSelectionInterval(0, 0);
        }

        public void save() {
            JFileChooser  dialog = new JFileChooser( "." );
            int rc = dialog.showSaveDialog( this );

            if ( rc == JFileChooser.APPROVE_OPTION ) {
                try {
                    File             file = dialog.getSelectedFile();
                    FileOutputStream out  = new FileOutputStream( file );

                    ListSelectionModel lsm = connectionTable.getSelectionModel();

                    rc = lsm.getLeadSelectionIndex();
                    if ( rc == 0 ) rc = connections.size();
                    Connection conn = (Connection) connections.get( rc - 1 );

                    rc = Integer.parseInt( portField.getText() );
                    out.write( (new String(tcpmon.getMessage("listenPort01", "Listen Port:") + " " + rc + "\n" )).getBytes() );
                    out.write( (new String(tcpmon.getMessage("targetHost01", "Target Host:") + " " + hostField.getText() +
                                "\n" )).getBytes() );
                    rc = Integer.parseInt( tPortField.getText() );
                    out.write( (new String(tcpmon.getMessage("targetPort01", "Target Port:") + " " + rc + "\n" )).getBytes() );

                    out.write( (new String("==== " + tcpmon.getMessage("request01", "Request") + " ====\n" )).getBytes() );
                    out.write( conn.inputText.getText().getBytes() );

                    out.write( (new String("==== " + tcpmon.getMessage("response00", "Response") + " ====\n" )).getBytes() );
                    out.write( conn.outputText.getText().getBytes() );

                    out.close();
                }
                catch ( Exception e ) {
                    e.printStackTrace();
                }
            }
        }

        public void resend() {
            int rc ;

            try {
                ListSelectionModel lsm = connectionTable.getSelectionModel();

                rc = lsm.getLeadSelectionIndex();
                if ( rc == 0 ) rc = connections.size();
                Connection conn = (Connection) connections.get( rc - 1 );

                if ( rc > 0 ) {
                    lsm.clearSelection();
                    lsm.setSelectionInterval(0, 0);
                }

                InputStream in = null ;
                String      text = conn.inputText.getText();

                // Fix Content-Length HTTP headers
                if ( text.startsWith("POST ") || text.startsWith("GET ") ) {
                    System.err.println("IN CL" );
                    int         pos1, pos2, pos3 ;
                    String      body, headers, headers1, header2 ;

                    pos3 = text.indexOf( "\n\n" );
                    if ( pos3 == -1 ) {
                        pos3 = text.indexOf( "\r\n\r\n" );
                        if ( pos3 != -1 ) pos3 = pos3 + 4 ;
                    }
                    else
                        pos3 += 2 ;

                    headers = text.substring( 0, pos3 );

                    pos1 = headers.indexOf( "Content-Length:" );
                    System.err.println("pos1: " + pos1 );
                    System.err.println("pos3: " + pos3 );
                    if ( pos1 != -1 ) {
                        int  newLen = text.length() - pos3 ;

                        pos2 = headers.indexOf( "\n", pos1 );

                        System.err.println("CL: " + newLen );
                        System.err.println("Hdrs: '" + headers + "'" );
                        System.err.println("subTEXT: '" +
                            text.substring(pos3, pos3 + newLen) + "'");
                        text = headers.substring(0, pos1) +
                        "Content-Length: " + newLen + "\n" +
                        headers.substring(pos2 + 1) +
                        text.substring(pos3) ;
                        System.err.println("\nTEXT: '" + text + "'" );
                    }
                }

                in = new ByteArrayInputStream( text.getBytes() );
                new Connection( this, in );
            }
            catch ( Exception e ) {
                e.printStackTrace();
            }
        }

    }

