package org.apache.axis.utils.tools;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.net.*;
import javax.swing.*;
import java.awt.Color;
import java.io.*;
import javax.swing.table.*;

public class SocketRR extends Thread {

  Socket        inSocket  = null ;
  Socket        outSocket  = null ;
  JTextArea     textArea ;
  InputStream   in = null ;
  OutputStream  out = null ;
  boolean       xmlFormat ;
  volatile boolean       done = false ;
  TableModel    tmodel = null ;
  int           tableIndex = 0 ;
  String type = null;
  Connection    myConnection = null;
  int messageLength=0;
  infoStruct infoOut=null;

  public SocketRR(Connection c, Socket inputSocket, InputStream inputStream,
      Socket outputSocket, OutputStream outputStream,
      JTextArea _textArea, infoStruct listener,boolean format,
      TableModel tModel, int index, final String type) {
      infoOut=listener;
      inSocket = inputSocket ;
      in       = inputStream ;
      outSocket = outputSocket ;
      out       = outputStream ;
      textArea  = _textArea ;
      xmlFormat = format ;
      tmodel    = tModel ;
      tableIndex = index ;
      this.type = type;
      myConnection = c;
      start();
  }

  public boolean isDone() {
      return ( done );
  }

  public void run() {
      try {
          byte[]      b1 = new byte[1];
          StringBuffer bufferData=null;

          byte[]      tmpbuffer = new byte[8192];
          int         saved = 0 ;
          int         len ;
          int         i1, i2 ;
          int         i ;
          int         reqSaved = 0 ;
          int         tabWidth = 3 ;
          boolean     atMargin = true ;
          int         thisIndent = -1,
              nextIndent = -1,
              previousIndent = -1;

          //if ( inSocket  != null ) inSocket.setSoTimeout( 10 );
          //if ( outSocket != null ) outSocket.setSoTimeout( 10 );

          if ( tmodel != null ) {
              String tmpStr = (String) tmodel.getValueAt(tableIndex,
                      tcpmon.REQ_COLUMN);

              if ( !"".equals(tmpStr) )
                  reqSaved = tmpStr.length();
          }

          a:
          for ( ; ; ) {
              if ( done ) break;
              //try{
              //len = in.available();
              //}catch(Exception e){len=0;}
              //len = buffer.length() ;
              // Used to be 1, but if we block it doesn't matter
              // however 1 will break with some servers, including apache
              //if ( len == 0 ) len = buffer.length;
              //if ( saved + len > buffer.length) len = buffer.length - saved ;
              int len1 = 0;
              bufferData=new StringBuffer();
              boolean recordResponseTime=false;
              //response time record get first byte time
              // require time record get last byte time
              for( ;; ) {

                  try {
                      len1 = in.read(b1, 0, 1);

                  if(len1<=0) {
                    done=true;
                    break;
                  }
                  String s1=new String(b1);
                  bufferData.append(s1);
                  if(type.equals("request:"))
                        infoOut.getRequireTime=System.currentTimeMillis();
                  else {
                    if(!recordResponseTime){
                      infoOut.getResponseTime = System.currentTimeMillis();
                      recordResponseTime=true;
                    }
                  }



                    if (out != null && len1 > 0) {
                      if(type.equals("request:"))
                        infoOut.writeOutRequireTime=System.currentTimeMillis();
                      else infoOut.writeOutResponseTime=System.currentTimeMillis();
                      out.write(s1.getBytes());
                    }
                    if ( b1[0] != '\n' )
                      continue ;
                  }
                  catch ( Exception ex ) {
                      if ( done && saved == 0  ) break a;
                      done=true;
                      len1 = -1;
                      break;
                  }


                    // we have a complete line


              }
              len = bufferData.length();
              if(type.equals("request:"))
                 infoOut.requireMessageLength=bufferData.toString().getBytes().length;
              else infoOut.responseMessageLength=bufferData.toString().getBytes().length;
               if ( len == -1 && saved == 0 ) break ;
              if ( len == -1) done = true;

              // No matter how we may (or may not) format it, send it
              // on unformatted - we don't want to mess with how its
              // sent to the other side, just how its displayed


              if ( tmodel != null && reqSaved < 50 ) {
                  String old = (String) tmodel.getValueAt( tableIndex,
                          tcpmon.REQ_COLUMN);

                  old = old + bufferData.toString();
                  if ( old.length() > 50 )
                      old = old.substring(0, 50);

                  reqSaved = old.length();

                  if ( (i = old.indexOf('\n')) > 0 ) {
                      old = old.substring(0, i - 1);
                      reqSaved = 50 ;
                  }

                  tmodel.setValueAt( old, tableIndex, tcpmon.REQ_COLUMN );
              }

              if ( xmlFormat ) {
                  // Do XML Formatting
                  boolean inXML = false ;
                  int     bufferLen = saved ;
                  byte[] buffer=bufferData.toString().getBytes();
                  if ( len != -1 ) bufferLen += len ;
                  i1 = 0 ;
                  i2 = 0 ;
                  saved = 0 ;
                  for ( ; i1 < bufferLen ; i1++ ) {
                      // Except when we're at EOF, saved last char
                      if ( len != -1 && i1 + 1 == bufferLen ) {
                          saved = 1;
                          break;
                      }
                      thisIndent = -1;
                      if ( buffer[i1] == '<' && buffer[i1 + 1] != '/' ) {
                          previousIndent = nextIndent++;
                          thisIndent = nextIndent;
                          inXML = true ;
                      }
                      if ( buffer[i1] == '<' && buffer[i1 + 1] == '/' ) {
                          if (previousIndent > nextIndent)
                              thisIndent = nextIndent;
                          previousIndent = nextIndent--;
                          inXML = true ;
                      }
                      if ( buffer[i1] == '/' && buffer[i1 + 1] == '>' ) {
                          previousIndent = nextIndent--;
                          inXML = true ;
                      }
                      if ( thisIndent != -1 ) {
                          if ( thisIndent > 0 ) tmpbuffer[i2++] = (byte) '\n';
                          for ( i = tabWidth * thisIndent; i > 0; i-- )
                              tmpbuffer[i2++] = (byte) ' ';
                      }
                      atMargin = ( buffer[i1] == '\n' || buffer[i1] == '\r');

                      if ( !inXML || !atMargin ) {
                          tmpbuffer[i2++] = buffer[i1];
                      }
                  }

                  textArea.append( new String( tmpbuffer, 0, i2 ) );

                  // Shift saved bytes to the beginning
                  for ( i = 0 ; i < saved ; i++ )
                      buffer[i] = buffer[bufferLen - saved + i];
              }
              else {
                  textArea.append( bufferData.toString() );
              }
          // this.sleep(3);  // Let other threads have a chance to run
          }
      // this.sleep(3);  // Let other threads have a chance to run
      // halt();
      // Only set the 'done' flag if we were reading from a
      // Socket - if we were reading from an input stream then
      // we'll let the other side control when we're done
      //      if ( inSocket != null ) done = true ;
      }
      catch ( Exception e ) {
          e.printStackTrace();
      }
      finally {
          done = true ;
          try {
              if (out != null) {
                  out.flush();
                  if (null != outSocket) outSocket.shutdownOutput();
                  else out.close();
                  out = null;
              }
          }
          catch (Exception e) {
              ;
          }
          try {
              if (in != null) {
                  if (inSocket != null) inSocket.shutdownInput();
                  else in.close();
                  in = null;
              }
          }
          catch (Exception e) {
              ;
          }
          myConnection.wakeUp();
      }
  }

  public  void halt() {
      try {
          if ( inSocket != null )  inSocket.close();
          if ( outSocket != null ) outSocket.close();
          inSocket  = null ;
          outSocket = null ;
          if ( in != null ) in.close();
          if ( out != null ) out.close();
          in = null ;
          out = null ;
          done = true;
      }
      catch ( Exception e ) {
          e.printStackTrace();
      }
  }
}
