package org.apache.axis.utils.tools;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.net.*;
import javax.swing.*;
import java.awt.Color;

public class SocketWaiter extends Thread {


    ServerSocket  sSocket = null ;
    Listener      listener ;
    int           port ;
    boolean       pleaseStop = false ;

    public SocketWaiter(Listener l, int p) {
        listener = l ;
        port = p ;
        start();
    }

    public void run() {
        try {
            listener.setLeft( new JLabel(tcpmon.getMessage("wait00", " Waiting for Connection...") ) );
            listener.repaint();
            sSocket = new ServerSocket( port );
            for (; ; ) {
                Socket inSocket = sSocket.accept();

                if ( pleaseStop ) break ;
                new Connection( listener, inSocket );
                inSocket = null ;
            }
        }
        catch ( Exception exp ) {
            if ( !"socket closed".equals(exp.getMessage()) ) {
                JLabel tmp = new JLabel( exp.toString() );

                tmp.setForeground( Color.red );
                listener.setLeft( tmp );
                listener.setRight( new JLabel("") );
                listener.stop();
            }
        }
    }

    public void halt() {
        try {
            pleaseStop = true ;
            new Socket( "127.0.0.1", port );
            if ( sSocket != null ) sSocket.close();
        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
    }
  }
