package testofsws2.testPrimitive2;

/**
 * <p>Title: testofSWS2</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import org.apache.axis.types.*;
import javax.xml.rpc.holders.*;
import org.omg.www.*;
import org.omg.www.holders.*;
import org.apache.axis.holders.*;

public class StubUsage {
   public static void main(String [] args) throws Exception{
          // Make a service
         Primitive2Service service = new Primitive2ServiceLocator();

          // Now use the service to get a stub which implements the SDI.
          Primitive2 port = service.getprimitive2(new java.net.URL("http://localhost:8080/starwebservice/services/urn:corba-primitive2"));

          // Make the actual call

          //test Boolean
          boolean nameb1=true;
          BooleanHolder nameb2=new BooleanHolder(true);
          BooleanHolder nameb3=new BooleanHolder(false);
          boolean echonameb=port.echoBoolean(nameb1,nameb2,nameb3);
          if (echonameb==false)
            System.out.println("test of Boolean is ok");

          //test Char
          _char namec1=new _char();
          namec1.setValue("a");
          _char value=new _char("b");
          _charHolder namec2=new _charHolder(value);
          _charHolder namec3=new _charHolder(value);
          _char echochar=port.echoChar(namec1,namec2,namec3);
          if ((echochar.getValue()).matches("a"))
            System.out.println("test of Char is ok");

         //test Wchar
         Wchar namewc1=new Wchar();
         namewc1.setValue("a");
         Wchar Value=new Wchar("b");
         WcharHolder namewc2=new WcharHolder(Value);
         WcharHolder namewc3=new WcharHolder(Value);
         Wchar echowchar=port.echoWChar(namewc1,namewc2,namewc3);
         if ((echowchar.getValue()).matches("a"))
           System.out.println("test of WChar is ok");

         //test Double
         double named1=3.54;
         DoubleHolder named2=new DoubleHolder(4.5);
         DoubleHolder named3=new DoubleHolder(4.5);
         if (port.echoDouble(named1,named2,named3)==3.54*3)
           System.out.println("test of Double is ok");

         //test Float
         float namef1=3.54f;
         FloatHolder namef2=new FloatHolder(1.1f);
         FloatHolder namef3=new FloatHolder(1.1f);
         if (port.echoFloat(namef1,namef2,namef3)==3.54f*3)
           System.out.println("test of Float is ok");

        //test Octet
        UnsignedByte nameo1=new UnsignedByte();
        long ssValue=7L;
        nameo1.setValue(ssValue);
        UnsignedByteHolder nameo2=new UnsignedByteHolder(nameo1);
        UnsignedByteHolder nameo3=new UnsignedByteHolder(nameo1);
        if ((port.echoOctet(nameo1,nameo2,nameo3)).longValue()==7l*3)
          System.out.println("test of Octet is ok");

        //test UnsignedLong
        int iValue=788;
        UnsignedInt nameui1=new UnsignedInt(iValue);
        UnsignedIntHolder nameui2=new UnsignedIntHolder(nameui1);
        UnsignedIntHolder nameui3=new UnsignedIntHolder(nameui1);
        if ((port.echouLong(nameui1,nameui2,nameui3)).intValue()==788*3)
          System.out.println("test of UnsignedLong is ok");

        //test Long
        int namei1=77;
        IntHolder namei2=new IntHolder(71);
        IntHolder namei3=new IntHolder(71);
        if (port.echoLong(namei1,namei2,namei3)==77*3)
          System.out.println("test of Long is ok");

         //test UnsignedShort
         long slValue=78L;
         UnsignedShort nameush1=new UnsignedShort(slValue);
         UnsignedShortHolder nameush2=new UnsignedShortHolder(nameush1);
         UnsignedShortHolder nameush3=new UnsignedShortHolder(nameush1);
         UnsignedShort echonamesh=port.echouShort(nameush1,nameush2,nameush3);
         if(echonamesh.shortValue()==slValue*3)
           System.out.println("test of UnsignedShort is ok");

         //test Short
         short namesh1=77;
         short shValue=-327;
         ShortHolder namesh2=new ShortHolder(shValue);
         ShortHolder namesh3=new ShortHolder(shValue);
         short echoshort=port.echoShort(namesh1,namesh2,namesh3);
         if (echoshort==namesh1*3)
           System.out.println("test of Short is ok");

          //test String
          String names1="hello ";
          StringHolder names2=new StringHolder("hh");
          StringHolder names3=new StringHolder("jj");
          //System.out.println(port.echoWString(names1,names2,names3));
          if((port.echoString(names1,names2,names3)).matches("hello 613 and jane"))
            System.out.println("test of String is ok");

          //test WString
          String namews1="hello ";
          StringHolder namews2=new StringHolder("hh");
          StringHolder namews3=new StringHolder("jj");
          if((port.echoWString(namews1,namews2,namews3)).matches("hello 613 and jane"))
            System.out.println("test of WString is ok");
          //System.out.println(port.echoWString(namews1,namews2,namews3));

          //test LongLong
          long namel1=55l;
          LongHolder namel2=new LongHolder(55l);
          LongHolder namel3=new LongHolder(55l);
          if(port.echoLongLong(namel1,namel2,namel3)==namel1*3)
            System.out.println("test of LongLong is ok");

            //test UnsignedLongLong
            double lValue=55;
            UnsignedLong nameul1=new UnsignedLong(lValue);
            UnsignedLongHolder nameul2=new UnsignedLongHolder(nameul1);
            UnsignedLongHolder nameul3=new UnsignedLongHolder(nameul1);
            UnsignedLong echoLongLong=port.echouLongLong(nameul1,nameul2,nameul3);
            if (echoLongLong.longValue()==lValue*3)
             System.out.println("test of UnsignedLongLong is ok");



   }
   }
