@echo off

rem
rem 
rem

setlocal

set STORETYPE=JKS
if not "%1" == "" set STORETYPE=%1

echo Creating RSA key pair...
keytool -genkey -alias Alice -keyalg RSA -dname "CN=Alice, O=IBM, C=US" -keypass keypass -keystore encryption_keystore2 -storepass storepass -storetype %STORETYPE%

echo Copying certificate of RSA public key...
keytool -export -alias Alice -file foo.cer -keystore encryption_keystore2 -storepass storepass -storetype %STORETYPE%
keytool -import -noprompt -alias Alice -file foo.cer -keystore encryption_keystore1 -storepass storepass -storetype %STORETYPE%
del foo.cer


endlocal

pause
