set KEYSTORE=client.jks
set STOREPASS=xmlsecurity
set ALIAS=client
set KEYPASS=xmlsecurity
set CERTFILE=client.cer

keytool -genkey -alias %ALIAS% -keyalg DSA -dname "CN=starwebservices" -keypass %KEYPASS% -storepass %STOREPASS% -keystore %KEYSTORE% -validity 2000
keytool -export -alias %ALIAS% -keystore %KEYSTORE% -storepass %STOREPASS% -file %CERTFILE%
rem java SignCert %CERTFILE% %ALIAS%

@echo on
:setClassPath
@set classpath=%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xmlParserAPIs.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xercesImpl.jar;%STARWS_HOME%\test\lib\XERCES.JAR;%STARWS_HOME%\test\lib\xalan.jar;%STARWS_HOME%\test\lib\tomcat-coyote.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\wsdl4j.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\STAR.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xss4j.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xml4j.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xmlsec.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\sunxacml.jar;%STARWS_HOME%\test\lib\j2ee.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\xercesSamples.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\log4j.jar;%STARWS_HOME%\test\lib\activation.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\icu4j_2_8.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\commons-discovery.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\are.jar;%STARWS_HOME%\test\lib\commons-daemon.jar;%STARWS_HOME%\test\lib\uddi4j.jar;%STARWS_HOME%\test\lib\commons-httpclient.jar;%STARWS_HOME%\test\lib\jimi.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\axis.jar;%STARWS_HOME%\webapps\starwebservice\WEB-INF\lib\sws.jar;

java -Dstarws.home=%STARWS_HOME% net.starmiddleware.starws2.security.rbac.SignCert -CAKeystoreFile "\test\testRBAC\bin\CAKeystore.jks" -CAStorepass xmlsecurity -CAKeypass xmlsecurity -CAStoretype JKS -CACertificateAlias root -CAPrivateKeyAlias root -ClientOriginalCertificateFile "\test\testRBAC\bin\client.cer" -ClientGeneratedKeystoreFile "\test\testRBAC\bin\tempkeystore.jks" -ClientGeneratedCertificateAlias client -ClientStorepass temppass


keytool -export -alias %ALIAS% -keystore tempkeystore.jks -storepass temppass -file ca_signed_for_%ALIAS%.cer
keytool -import -noprompt -alias root -keystore %KEYSTORE% -storepass %STOREPASS% -file CA.cer
keytool -import -noprompt -alias %ALIAS% -keystore %KEYSTORE% -storepass %STOREPASS% -file ca_signed_for_%ALIAS%.cer
del tempkeystore.jks
keytool -list -keystore %KEYSTORE% -storepass %STOREPASS% -v

pause